/*
 * Copyright (C) 2013-  Qiming Sun <osirpt.sun@gmail.com>
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include "cint_bas.h"
#include "cart2sph.h"
#include "g2e.h"
#include "g3c1e.h"
#include "g3c2e.h"
#include "g2c2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "fblas.h"
#include "c2f.h"
/* (i j|CCC1E |P DOT P k) */
void CINTgout3c1e_cint3c1e_p2_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double s[9];
G3C1E_D_K(g1, g0, i_l+0, j_l+0, k_l+1);
G3C1E_D_K(g2, g0, i_l+0, j_l+0, k_l+0);
G3C1E_D_K(g3, g1, i_l+0, j_l+0, k_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
if (gout_empty) {
gout[0] = + (-1*s[0]) + (-1*s[4]) + (-1*s[8]);
gout += 1;
} else {
gout[0] += + (-1*s[0]) + (-1*s[4]) + (-1*s[8]);
gout += 1;
}}}
void cint3c1e_p2_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
*opt = NULL;
}
FINT cint3c1e_p2_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {0, 0, 2, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int3c1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout3c1e_cint3c1e_p2_sph;
envs.common_factor *= 1;
return CINT3c1e_spheric_drv(opijkl, &envs, opt, &c2s_sph_3c1e, 0);
}
OPTIMIZER2F_(cint3c1e_p2_sph_optimizer);
C2Fo_(cint3c1e_p2_sph)
/* (i j|CCC1E |R DOT R k) */
void CINTgout3c1e_cint3c1e_r2_origk_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double s[9];
G3C1E_R_K(g1, g0, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g2, g0, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g3, g1, i_l+0, j_l+0, k_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
if (gout_empty) {
gout[0] = + s[0] + s[4] + s[8];
gout += 1;
} else {
gout[0] += + s[0] + s[4] + s[8];
gout += 1;
}}}
void cint3c1e_r2_origk_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
*opt = NULL;
}
FINT cint3c1e_r2_origk_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {0, 0, 2, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int3c1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout3c1e_cint3c1e_r2_origk_sph;
envs.common_factor *= 1;
return CINT3c1e_spheric_drv(opijkl, &envs, opt, &c2s_sph_3c1e, 0);
}
OPTIMIZER2F_(cint3c1e_r2_origk_sph_optimizer);
C2Fo_(cint3c1e_r2_origk_sph)
/* (i j|CCC1E |R DOT R R DOT R k) */
void CINTgout3c1e_cint3c1e_r4_origk_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double s[81];
G3C1E_R_K(g1, g0, i_l+0, j_l+0, k_l+3);
G3C1E_R_K(g2, g0, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g3, g1, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g4, g0, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g5, g1, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g6, g2, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g7, g3, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g8, g0, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g9, g1, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g10, g2, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g11, g3, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g12, g4, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g13, g5, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g14, g6, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g15, g7, i_l+0, j_l+0, k_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g15[ix] * g0[iy] * g0[iz];
s[1] = g14[ix] * g1[iy] * g0[iz];
s[2] = g14[ix] * g0[iy] * g1[iz];
s[3] = g13[ix] * g2[iy] * g0[iz];
s[4] = g12[ix] * g3[iy] * g0[iz];
s[5] = g12[ix] * g2[iy] * g1[iz];
s[6] = g13[ix] * g0[iy] * g2[iz];
s[7] = g12[ix] * g1[iy] * g2[iz];
s[8] = g12[ix] * g0[iy] * g3[iz];
s[9] = g11[ix] * g4[iy] * g0[iz];
s[10] = g10[ix] * g5[iy] * g0[iz];
s[11] = g10[ix] * g4[iy] * g1[iz];
s[12] = g9[ix] * g6[iy] * g0[iz];
s[13] = g8[ix] * g7[iy] * g0[iz];
s[14] = g8[ix] * g6[iy] * g1[iz];
s[15] = g9[ix] * g4[iy] * g2[iz];
s[16] = g8[ix] * g5[iy] * g2[iz];
s[17] = g8[ix] * g4[iy] * g3[iz];
s[18] = g11[ix] * g0[iy] * g4[iz];
s[19] = g10[ix] * g1[iy] * g4[iz];
s[20] = g10[ix] * g0[iy] * g5[iz];
s[21] = g9[ix] * g2[iy] * g4[iz];
s[22] = g8[ix] * g3[iy] * g4[iz];
s[23] = g8[ix] * g2[iy] * g5[iz];
s[24] = g9[ix] * g0[iy] * g6[iz];
s[25] = g8[ix] * g1[iy] * g6[iz];
s[26] = g8[ix] * g0[iy] * g7[iz];
s[27] = g7[ix] * g8[iy] * g0[iz];
s[28] = g6[ix] * g9[iy] * g0[iz];
s[29] = g6[ix] * g8[iy] * g1[iz];
s[30] = g5[ix] * g10[iy] * g0[iz];
s[31] = g4[ix] * g11[iy] * g0[iz];
s[32] = g4[ix] * g10[iy] * g1[iz];
s[33] = g5[ix] * g8[iy] * g2[iz];
s[34] = g4[ix] * g9[iy] * g2[iz];
s[35] = g4[ix] * g8[iy] * g3[iz];
s[36] = g3[ix] * g12[iy] * g0[iz];
s[37] = g2[ix] * g13[iy] * g0[iz];
s[38] = g2[ix] * g12[iy] * g1[iz];
s[39] = g1[ix] * g14[iy] * g0[iz];
s[40] = g0[ix] * g15[iy] * g0[iz];
s[41] = g0[ix] * g14[iy] * g1[iz];
s[42] = g1[ix] * g12[iy] * g2[iz];
s[43] = g0[ix] * g13[iy] * g2[iz];
s[44] = g0[ix] * g12[iy] * g3[iz];
s[45] = g3[ix] * g8[iy] * g4[iz];
s[46] = g2[ix] * g9[iy] * g4[iz];
s[47] = g2[ix] * g8[iy] * g5[iz];
s[48] = g1[ix] * g10[iy] * g4[iz];
s[49] = g0[ix] * g11[iy] * g4[iz];
s[50] = g0[ix] * g10[iy] * g5[iz];
s[51] = g1[ix] * g8[iy] * g6[iz];
s[52] = g0[ix] * g9[iy] * g6[iz];
s[53] = g0[ix] * g8[iy] * g7[iz];
s[54] = g7[ix] * g0[iy] * g8[iz];
s[55] = g6[ix] * g1[iy] * g8[iz];
s[56] = g6[ix] * g0[iy] * g9[iz];
s[57] = g5[ix] * g2[iy] * g8[iz];
s[58] = g4[ix] * g3[iy] * g8[iz];
s[59] = g4[ix] * g2[iy] * g9[iz];
s[60] = g5[ix] * g0[iy] * g10[iz];
s[61] = g4[ix] * g1[iy] * g10[iz];
s[62] = g4[ix] * g0[iy] * g11[iz];
s[63] = g3[ix] * g4[iy] * g8[iz];
s[64] = g2[ix] * g5[iy] * g8[iz];
s[65] = g2[ix] * g4[iy] * g9[iz];
s[66] = g1[ix] * g6[iy] * g8[iz];
s[67] = g0[ix] * g7[iy] * g8[iz];
s[68] = g0[ix] * g6[iy] * g9[iz];
s[69] = g1[ix] * g4[iy] * g10[iz];
s[70] = g0[ix] * g5[iy] * g10[iz];
s[71] = g0[ix] * g4[iy] * g11[iz];
s[72] = g3[ix] * g0[iy] * g12[iz];
s[73] = g2[ix] * g1[iy] * g12[iz];
s[74] = g2[ix] * g0[iy] * g13[iz];
s[75] = g1[ix] * g2[iy] * g12[iz];
s[76] = g0[ix] * g3[iy] * g12[iz];
s[77] = g0[ix] * g2[iy] * g13[iz];
s[78] = g1[ix] * g0[iy] * g14[iz];
s[79] = g0[ix] * g1[iy] * g14[iz];
s[80] = g0[ix] * g0[iy] * g15[iz];
if (gout_empty) {
gout[0] = + s[0] + (2*s[4]) + (2*s[8]) + s[40] + (2*s[44]) + s[80];
gout += 1;
} else {
gout[0] += + s[0] + (2*s[4]) + (2*s[8]) + s[40] + (2*s[44]) + s[80];
gout += 1;
}}}
void cint3c1e_r4_origk_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
*opt = NULL;
}
FINT cint3c1e_r4_origk_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {0, 0, 4, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int3c1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout3c1e_cint3c1e_r4_origk_sph;
envs.common_factor *= 1;
return CINT3c1e_spheric_drv(opijkl, &envs, opt, &c2s_sph_3c1e, 0);
}
OPTIMIZER2F_(cint3c1e_r4_origk_sph_optimizer);
C2Fo_(cint3c1e_r4_origk_sph)
/* (i j|CCC1E |R DOT R R DOT R R DOT R k) */
void CINTgout3c1e_cint3c1e_r6_origk_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double s[729];
G3C1E_R_K(g1, g0, i_l+0, j_l+0, k_l+5);
G3C1E_R_K(g2, g0, i_l+0, j_l+0, k_l+4);
G3C1E_R_K(g3, g1, i_l+0, j_l+0, k_l+4);
G3C1E_R_K(g4, g0, i_l+0, j_l+0, k_l+3);
G3C1E_R_K(g5, g1, i_l+0, j_l+0, k_l+3);
G3C1E_R_K(g6, g2, i_l+0, j_l+0, k_l+3);
G3C1E_R_K(g7, g3, i_l+0, j_l+0, k_l+3);
G3C1E_R_K(g8, g0, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g9, g1, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g10, g2, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g11, g3, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g12, g4, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g13, g5, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g14, g6, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g15, g7, i_l+0, j_l+0, k_l+2);
G3C1E_R_K(g16, g0, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g17, g1, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g18, g2, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g19, g3, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g20, g4, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g21, g5, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g22, g6, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g23, g7, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g24, g8, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g25, g9, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g26, g10, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g27, g11, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g28, g12, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g29, g13, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g30, g14, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g31, g15, i_l+0, j_l+0, k_l+1);
G3C1E_R_K(g32, g0, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g33, g1, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g34, g2, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g35, g3, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g36, g4, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g37, g5, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g38, g6, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g39, g7, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g40, g8, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g41, g9, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g42, g10, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g43, g11, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g44, g12, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g45, g13, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g46, g14, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g47, g15, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g48, g16, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g49, g17, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g50, g18, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g51, g19, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g52, g20, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g53, g21, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g54, g22, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g55, g23, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g56, g24, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g57, g25, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g58, g26, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g59, g27, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g60, g28, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g61, g29, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g62, g30, i_l+0, j_l+0, k_l+0);
G3C1E_R_K(g63, g31, i_l+0, j_l+0, k_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g63[ix] * g0[iy] * g0[iz];
s[1] = g62[ix] * g1[iy] * g0[iz];
s[2] = g62[ix] * g0[iy] * g1[iz];
s[3] = g61[ix] * g2[iy] * g0[iz];
s[4] = g60[ix] * g3[iy] * g0[iz];
s[5] = g60[ix] * g2[iy] * g1[iz];
s[6] = g61[ix] * g0[iy] * g2[iz];
s[7] = g60[ix] * g1[iy] * g2[iz];
s[8] = g60[ix] * g0[iy] * g3[iz];
s[9] = g59[ix] * g4[iy] * g0[iz];
s[10] = g58[ix] * g5[iy] * g0[iz];
s[11] = g58[ix] * g4[iy] * g1[iz];
s[12] = g57[ix] * g6[iy] * g0[iz];
s[13] = g56[ix] * g7[iy] * g0[iz];
s[14] = g56[ix] * g6[iy] * g1[iz];
s[15] = g57[ix] * g4[iy] * g2[iz];
s[16] = g56[ix] * g5[iy] * g2[iz];
s[17] = g56[ix] * g4[iy] * g3[iz];
s[18] = g59[ix] * g0[iy] * g4[iz];
s[19] = g58[ix] * g1[iy] * g4[iz];
s[20] = g58[ix] * g0[iy] * g5[iz];
s[21] = g57[ix] * g2[iy] * g4[iz];
s[22] = g56[ix] * g3[iy] * g4[iz];
s[23] = g56[ix] * g2[iy] * g5[iz];
s[24] = g57[ix] * g0[iy] * g6[iz];
s[25] = g56[ix] * g1[iy] * g6[iz];
s[26] = g56[ix] * g0[iy] * g7[iz];
s[27] = g55[ix] * g8[iy] * g0[iz];
s[28] = g54[ix] * g9[iy] * g0[iz];
s[29] = g54[ix] * g8[iy] * g1[iz];
s[30] = g53[ix] * g10[iy] * g0[iz];
s[31] = g52[ix] * g11[iy] * g0[iz];
s[32] = g52[ix] * g10[iy] * g1[iz];
s[33] = g53[ix] * g8[iy] * g2[iz];
s[34] = g52[ix] * g9[iy] * g2[iz];
s[35] = g52[ix] * g8[iy] * g3[iz];
s[36] = g51[ix] * g12[iy] * g0[iz];
s[37] = g50[ix] * g13[iy] * g0[iz];
s[38] = g50[ix] * g12[iy] * g1[iz];
s[39] = g49[ix] * g14[iy] * g0[iz];
s[40] = g48[ix] * g15[iy] * g0[iz];
s[41] = g48[ix] * g14[iy] * g1[iz];
s[42] = g49[ix] * g12[iy] * g2[iz];
s[43] = g48[ix] * g13[iy] * g2[iz];
s[44] = g48[ix] * g12[iy] * g3[iz];
s[45] = g51[ix] * g8[iy] * g4[iz];
s[46] = g50[ix] * g9[iy] * g4[iz];
s[47] = g50[ix] * g8[iy] * g5[iz];
s[48] = g49[ix] * g10[iy] * g4[iz];
s[49] = g48[ix] * g11[iy] * g4[iz];
s[50] = g48[ix] * g10[iy] * g5[iz];
s[51] = g49[ix] * g8[iy] * g6[iz];
s[52] = g48[ix] * g9[iy] * g6[iz];
s[53] = g48[ix] * g8[iy] * g7[iz];
s[54] = g55[ix] * g0[iy] * g8[iz];
s[55] = g54[ix] * g1[iy] * g8[iz];
s[56] = g54[ix] * g0[iy] * g9[iz];
s[57] = g53[ix] * g2[iy] * g8[iz];
s[58] = g52[ix] * g3[iy] * g8[iz];
s[59] = g52[ix] * g2[iy] * g9[iz];
s[60] = g53[ix] * g0[iy] * g10[iz];
s[61] = g52[ix] * g1[iy] * g10[iz];
s[62] = g52[ix] * g0[iy] * g11[iz];
s[63] = g51[ix] * g4[iy] * g8[iz];
s[64] = g50[ix] * g5[iy] * g8[iz];
s[65] = g50[ix] * g4[iy] * g9[iz];
s[66] = g49[ix] * g6[iy] * g8[iz];
s[67] = g48[ix] * g7[iy] * g8[iz];
s[68] = g48[ix] * g6[iy] * g9[iz];
s[69] = g49[ix] * g4[iy] * g10[iz];
s[70] = g48[ix] * g5[iy] * g10[iz];
s[71] = g48[ix] * g4[iy] * g11[iz];
s[72] = g51[ix] * g0[iy] * g12[iz];
s[73] = g50[ix] * g1[iy] * g12[iz];
s[74] = g50[ix] * g0[iy] * g13[iz];
s[75] = g49[ix] * g2[iy] * g12[iz];
s[76] = g48[ix] * g3[iy] * g12[iz];
s[77] = g48[ix] * g2[iy] * g13[iz];
s[78] = g49[ix] * g0[iy] * g14[iz];
s[79] = g48[ix] * g1[iy] * g14[iz];
s[80] = g48[ix] * g0[iy] * g15[iz];
s[81] = g47[ix] * g16[iy] * g0[iz];
s[82] = g46[ix] * g17[iy] * g0[iz];
s[83] = g46[ix] * g16[iy] * g1[iz];
s[84] = g45[ix] * g18[iy] * g0[iz];
s[85] = g44[ix] * g19[iy] * g0[iz];
s[86] = g44[ix] * g18[iy] * g1[iz];
s[87] = g45[ix] * g16[iy] * g2[iz];
s[88] = g44[ix] * g17[iy] * g2[iz];
s[89] = g44[ix] * g16[iy] * g3[iz];
s[90] = g43[ix] * g20[iy] * g0[iz];
s[91] = g42[ix] * g21[iy] * g0[iz];
s[92] = g42[ix] * g20[iy] * g1[iz];
s[93] = g41[ix] * g22[iy] * g0[iz];
s[94] = g40[ix] * g23[iy] * g0[iz];
s[95] = g40[ix] * g22[iy] * g1[iz];
s[96] = g41[ix] * g20[iy] * g2[iz];
s[97] = g40[ix] * g21[iy] * g2[iz];
s[98] = g40[ix] * g20[iy] * g3[iz];
s[99] = g43[ix] * g16[iy] * g4[iz];
s[100] = g42[ix] * g17[iy] * g4[iz];
s[101] = g42[ix] * g16[iy] * g5[iz];
s[102] = g41[ix] * g18[iy] * g4[iz];
s[103] = g40[ix] * g19[iy] * g4[iz];
s[104] = g40[ix] * g18[iy] * g5[iz];
s[105] = g41[ix] * g16[iy] * g6[iz];
s[106] = g40[ix] * g17[iy] * g6[iz];
s[107] = g40[ix] * g16[iy] * g7[iz];
s[108] = g39[ix] * g24[iy] * g0[iz];
s[109] = g38[ix] * g25[iy] * g0[iz];
s[110] = g38[ix] * g24[iy] * g1[iz];
s[111] = g37[ix] * g26[iy] * g0[iz];
s[112] = g36[ix] * g27[iy] * g0[iz];
s[113] = g36[ix] * g26[iy] * g1[iz];
s[114] = g37[ix] * g24[iy] * g2[iz];
s[115] = g36[ix] * g25[iy] * g2[iz];
s[116] = g36[ix] * g24[iy] * g3[iz];
s[117] = g35[ix] * g28[iy] * g0[iz];
s[118] = g34[ix] * g29[iy] * g0[iz];
s[119] = g34[ix] * g28[iy] * g1[iz];
s[120] = g33[ix] * g30[iy] * g0[iz];
s[121] = g32[ix] * g31[iy] * g0[iz];
s[122] = g32[ix] * g30[iy] * g1[iz];
s[123] = g33[ix] * g28[iy] * g2[iz];
s[124] = g32[ix] * g29[iy] * g2[iz];
s[125] = g32[ix] * g28[iy] * g3[iz];
s[126] = g35[ix] * g24[iy] * g4[iz];
s[127] = g34[ix] * g25[iy] * g4[iz];
s[128] = g34[ix] * g24[iy] * g5[iz];
s[129] = g33[ix] * g26[iy] * g4[iz];
s[130] = g32[ix] * g27[iy] * g4[iz];
s[131] = g32[ix] * g26[iy] * g5[iz];
s[132] = g33[ix] * g24[iy] * g6[iz];
s[133] = g32[ix] * g25[iy] * g6[iz];
s[134] = g32[ix] * g24[iy] * g7[iz];
s[135] = g39[ix] * g16[iy] * g8[iz];
s[136] = g38[ix] * g17[iy] * g8[iz];
s[137] = g38[ix] * g16[iy] * g9[iz];
s[138] = g37[ix] * g18[iy] * g8[iz];
s[139] = g36[ix] * g19[iy] * g8[iz];
s[140] = g36[ix] * g18[iy] * g9[iz];
s[141] = g37[ix] * g16[iy] * g10[iz];
s[142] = g36[ix] * g17[iy] * g10[iz];
s[143] = g36[ix] * g16[iy] * g11[iz];
s[144] = g35[ix] * g20[iy] * g8[iz];
s[145] = g34[ix] * g21[iy] * g8[iz];
s[146] = g34[ix] * g20[iy] * g9[iz];
s[147] = g33[ix] * g22[iy] * g8[iz];
s[148] = g32[ix] * g23[iy] * g8[iz];
s[149] = g32[ix] * g22[iy] * g9[iz];
s[150] = g33[ix] * g20[iy] * g10[iz];
s[151] = g32[ix] * g21[iy] * g10[iz];
s[152] = g32[ix] * g20[iy] * g11[iz];
s[153] = g35[ix] * g16[iy] * g12[iz];
s[154] = g34[ix] * g17[iy] * g12[iz];
s[155] = g34[ix] * g16[iy] * g13[iz];
s[156] = g33[ix] * g18[iy] * g12[iz];
s[157] = g32[ix] * g19[iy] * g12[iz];
s[158] = g32[ix] * g18[iy] * g13[iz];
s[159] = g33[ix] * g16[iy] * g14[iz];
s[160] = g32[ix] * g17[iy] * g14[iz];
s[161] = g32[ix] * g16[iy] * g15[iz];
s[162] = g47[ix] * g0[iy] * g16[iz];
s[163] = g46[ix] * g1[iy] * g16[iz];
s[164] = g46[ix] * g0[iy] * g17[iz];
s[165] = g45[ix] * g2[iy] * g16[iz];
s[166] = g44[ix] * g3[iy] * g16[iz];
s[167] = g44[ix] * g2[iy] * g17[iz];
s[168] = g45[ix] * g0[iy] * g18[iz];
s[169] = g44[ix] * g1[iy] * g18[iz];
s[170] = g44[ix] * g0[iy] * g19[iz];
s[171] = g43[ix] * g4[iy] * g16[iz];
s[172] = g42[ix] * g5[iy] * g16[iz];
s[173] = g42[ix] * g4[iy] * g17[iz];
s[174] = g41[ix] * g6[iy] * g16[iz];
s[175] = g40[ix] * g7[iy] * g16[iz];
s[176] = g40[ix] * g6[iy] * g17[iz];
s[177] = g41[ix] * g4[iy] * g18[iz];
s[178] = g40[ix] * g5[iy] * g18[iz];
s[179] = g40[ix] * g4[iy] * g19[iz];
s[180] = g43[ix] * g0[iy] * g20[iz];
s[181] = g42[ix] * g1[iy] * g20[iz];
s[182] = g42[ix] * g0[iy] * g21[iz];
s[183] = g41[ix] * g2[iy] * g20[iz];
s[184] = g40[ix] * g3[iy] * g20[iz];
s[185] = g40[ix] * g2[iy] * g21[iz];
s[186] = g41[ix] * g0[iy] * g22[iz];
s[187] = g40[ix] * g1[iy] * g22[iz];
s[188] = g40[ix] * g0[iy] * g23[iz];
s[189] = g39[ix] * g8[iy] * g16[iz];
s[190] = g38[ix] * g9[iy] * g16[iz];
s[191] = g38[ix] * g8[iy] * g17[iz];
s[192] = g37[ix] * g10[iy] * g16[iz];
s[193] = g36[ix] * g11[iy] * g16[iz];
s[194] = g36[ix] * g10[iy] * g17[iz];
s[195] = g37[ix] * g8[iy] * g18[iz];
s[196] = g36[ix] * g9[iy] * g18[iz];
s[197] = g36[ix] * g8[iy] * g19[iz];
s[198] = g35[ix] * g12[iy] * g16[iz];
s[199] = g34[ix] * g13[iy] * g16[iz];
s[200] = g34[ix] * g12[iy] * g17[iz];
s[201] = g33[ix] * g14[iy] * g16[iz];
s[202] = g32[ix] * g15[iy] * g16[iz];
s[203] = g32[ix] * g14[iy] * g17[iz];
s[204] = g33[ix] * g12[iy] * g18[iz];
s[205] = g32[ix] * g13[iy] * g18[iz];
s[206] = g32[ix] * g12[iy] * g19[iz];
s[207] = g35[ix] * g8[iy] * g20[iz];
s[208] = g34[ix] * g9[iy] * g20[iz];
s[209] = g34[ix] * g8[iy] * g21[iz];
s[210] = g33[ix] * g10[iy] * g20[iz];
s[211] = g32[ix] * g11[iy] * g20[iz];
s[212] = g32[ix] * g10[iy] * g21[iz];
s[213] = g33[ix] * g8[iy] * g22[iz];
s[214] = g32[ix] * g9[iy] * g22[iz];
s[215] = g32[ix] * g8[iy] * g23[iz];
s[216] = g39[ix] * g0[iy] * g24[iz];
s[217] = g38[ix] * g1[iy] * g24[iz];
s[218] = g38[ix] * g0[iy] * g25[iz];
s[219] = g37[ix] * g2[iy] * g24[iz];
s[220] = g36[ix] * g3[iy] * g24[iz];
s[221] = g36[ix] * g2[iy] * g25[iz];
s[222] = g37[ix] * g0[iy] * g26[iz];
s[223] = g36[ix] * g1[iy] * g26[iz];
s[224] = g36[ix] * g0[iy] * g27[iz];
s[225] = g35[ix] * g4[iy] * g24[iz];
s[226] = g34[ix] * g5[iy] * g24[iz];
s[227] = g34[ix] * g4[iy] * g25[iz];
s[228] = g33[ix] * g6[iy] * g24[iz];
s[229] = g32[ix] * g7[iy] * g24[iz];
s[230] = g32[ix] * g6[iy] * g25[iz];
s[231] = g33[ix] * g4[iy] * g26[iz];
s[232] = g32[ix] * g5[iy] * g26[iz];
s[233] = g32[ix] * g4[iy] * g27[iz];
s[234] = g35[ix] * g0[iy] * g28[iz];
s[235] = g34[ix] * g1[iy] * g28[iz];
s[236] = g34[ix] * g0[iy] * g29[iz];
s[237] = g33[ix] * g2[iy] * g28[iz];
s[238] = g32[ix] * g3[iy] * g28[iz];
s[239] = g32[ix] * g2[iy] * g29[iz];
s[240] = g33[ix] * g0[iy] * g30[iz];
s[241] = g32[ix] * g1[iy] * g30[iz];
s[242] = g32[ix] * g0[iy] * g31[iz];
s[243] = g31[ix] * g32[iy] * g0[iz];
s[244] = g30[ix] * g33[iy] * g0[iz];
s[245] = g30[ix] * g32[iy] * g1[iz];
s[246] = g29[ix] * g34[iy] * g0[iz];
s[247] = g28[ix] * g35[iy] * g0[iz];
s[248] = g28[ix] * g34[iy] * g1[iz];
s[249] = g29[ix] * g32[iy] * g2[iz];
s[250] = g28[ix] * g33[iy] * g2[iz];
s[251] = g28[ix] * g32[iy] * g3[iz];
s[252] = g27[ix] * g36[iy] * g0[iz];
s[253] = g26[ix] * g37[iy] * g0[iz];
s[254] = g26[ix] * g36[iy] * g1[iz];
s[255] = g25[ix] * g38[iy] * g0[iz];
s[256] = g24[ix] * g39[iy] * g0[iz];
s[257] = g24[ix] * g38[iy] * g1[iz];
s[258] = g25[ix] * g36[iy] * g2[iz];
s[259] = g24[ix] * g37[iy] * g2[iz];
s[260] = g24[ix] * g36[iy] * g3[iz];
s[261] = g27[ix] * g32[iy] * g4[iz];
s[262] = g26[ix] * g33[iy] * g4[iz];
s[263] = g26[ix] * g32[iy] * g5[iz];
s[264] = g25[ix] * g34[iy] * g4[iz];
s[265] = g24[ix] * g35[iy] * g4[iz];
s[266] = g24[ix] * g34[iy] * g5[iz];
s[267] = g25[ix] * g32[iy] * g6[iz];
s[268] = g24[ix] * g33[iy] * g6[iz];
s[269] = g24[ix] * g32[iy] * g7[iz];
s[270] = g23[ix] * g40[iy] * g0[iz];
s[271] = g22[ix] * g41[iy] * g0[iz];
s[272] = g22[ix] * g40[iy] * g1[iz];
s[273] = g21[ix] * g42[iy] * g0[iz];
s[274] = g20[ix] * g43[iy] * g0[iz];
s[275] = g20[ix] * g42[iy] * g1[iz];
s[276] = g21[ix] * g40[iy] * g2[iz];
s[277] = g20[ix] * g41[iy] * g2[iz];
s[278] = g20[ix] * g40[iy] * g3[iz];
s[279] = g19[ix] * g44[iy] * g0[iz];
s[280] = g18[ix] * g45[iy] * g0[iz];
s[281] = g18[ix] * g44[iy] * g1[iz];
s[282] = g17[ix] * g46[iy] * g0[iz];
s[283] = g16[ix] * g47[iy] * g0[iz];
s[284] = g16[ix] * g46[iy] * g1[iz];
s[285] = g17[ix] * g44[iy] * g2[iz];
s[286] = g16[ix] * g45[iy] * g2[iz];
s[287] = g16[ix] * g44[iy] * g3[iz];
s[288] = g19[ix] * g40[iy] * g4[iz];
s[289] = g18[ix] * g41[iy] * g4[iz];
s[290] = g18[ix] * g40[iy] * g5[iz];
s[291] = g17[ix] * g42[iy] * g4[iz];
s[292] = g16[ix] * g43[iy] * g4[iz];
s[293] = g16[ix] * g42[iy] * g5[iz];
s[294] = g17[ix] * g40[iy] * g6[iz];
s[295] = g16[ix] * g41[iy] * g6[iz];
s[296] = g16[ix] * g40[iy] * g7[iz];
s[297] = g23[ix] * g32[iy] * g8[iz];
s[298] = g22[ix] * g33[iy] * g8[iz];
s[299] = g22[ix] * g32[iy] * g9[iz];
s[300] = g21[ix] * g34[iy] * g8[iz];
s[301] = g20[ix] * g35[iy] * g8[iz];
s[302] = g20[ix] * g34[iy] * g9[iz];
s[303] = g21[ix] * g32[iy] * g10[iz];
s[304] = g20[ix] * g33[iy] * g10[iz];
s[305] = g20[ix] * g32[iy] * g11[iz];
s[306] = g19[ix] * g36[iy] * g8[iz];
s[307] = g18[ix] * g37[iy] * g8[iz];
s[308] = g18[ix] * g36[iy] * g9[iz];
s[309] = g17[ix] * g38[iy] * g8[iz];
s[310] = g16[ix] * g39[iy] * g8[iz];
s[311] = g16[ix] * g38[iy] * g9[iz];
s[312] = g17[ix] * g36[iy] * g10[iz];
s[313] = g16[ix] * g37[iy] * g10[iz];
s[314] = g16[ix] * g36[iy] * g11[iz];
s[315] = g19[ix] * g32[iy] * g12[iz];
s[316] = g18[ix] * g33[iy] * g12[iz];
s[317] = g18[ix] * g32[iy] * g13[iz];
s[318] = g17[ix] * g34[iy] * g12[iz];
s[319] = g16[ix] * g35[iy] * g12[iz];
s[320] = g16[ix] * g34[iy] * g13[iz];
s[321] = g17[ix] * g32[iy] * g14[iz];
s[322] = g16[ix] * g33[iy] * g14[iz];
s[323] = g16[ix] * g32[iy] * g15[iz];
s[324] = g15[ix] * g48[iy] * g0[iz];
s[325] = g14[ix] * g49[iy] * g0[iz];
s[326] = g14[ix] * g48[iy] * g1[iz];
s[327] = g13[ix] * g50[iy] * g0[iz];
s[328] = g12[ix] * g51[iy] * g0[iz];
s[329] = g12[ix] * g50[iy] * g1[iz];
s[330] = g13[ix] * g48[iy] * g2[iz];
s[331] = g12[ix] * g49[iy] * g2[iz];
s[332] = g12[ix] * g48[iy] * g3[iz];
s[333] = g11[ix] * g52[iy] * g0[iz];
s[334] = g10[ix] * g53[iy] * g0[iz];
s[335] = g10[ix] * g52[iy] * g1[iz];
s[336] = g9[ix] * g54[iy] * g0[iz];
s[337] = g8[ix] * g55[iy] * g0[iz];
s[338] = g8[ix] * g54[iy] * g1[iz];
s[339] = g9[ix] * g52[iy] * g2[iz];
s[340] = g8[ix] * g53[iy] * g2[iz];
s[341] = g8[ix] * g52[iy] * g3[iz];
s[342] = g11[ix] * g48[iy] * g4[iz];
s[343] = g10[ix] * g49[iy] * g4[iz];
s[344] = g10[ix] * g48[iy] * g5[iz];
s[345] = g9[ix] * g50[iy] * g4[iz];
s[346] = g8[ix] * g51[iy] * g4[iz];
s[347] = g8[ix] * g50[iy] * g5[iz];
s[348] = g9[ix] * g48[iy] * g6[iz];
s[349] = g8[ix] * g49[iy] * g6[iz];
s[350] = g8[ix] * g48[iy] * g7[iz];
s[351] = g7[ix] * g56[iy] * g0[iz];
s[352] = g6[ix] * g57[iy] * g0[iz];
s[353] = g6[ix] * g56[iy] * g1[iz];
s[354] = g5[ix] * g58[iy] * g0[iz];
s[355] = g4[ix] * g59[iy] * g0[iz];
s[356] = g4[ix] * g58[iy] * g1[iz];
s[357] = g5[ix] * g56[iy] * g2[iz];
s[358] = g4[ix] * g57[iy] * g2[iz];
s[359] = g4[ix] * g56[iy] * g3[iz];
s[360] = g3[ix] * g60[iy] * g0[iz];
s[361] = g2[ix] * g61[iy] * g0[iz];
s[362] = g2[ix] * g60[iy] * g1[iz];
s[363] = g1[ix] * g62[iy] * g0[iz];
s[364] = g0[ix] * g63[iy] * g0[iz];
s[365] = g0[ix] * g62[iy] * g1[iz];
s[366] = g1[ix] * g60[iy] * g2[iz];
s[367] = g0[ix] * g61[iy] * g2[iz];
s[368] = g0[ix] * g60[iy] * g3[iz];
s[369] = g3[ix] * g56[iy] * g4[iz];
s[370] = g2[ix] * g57[iy] * g4[iz];
s[371] = g2[ix] * g56[iy] * g5[iz];
s[372] = g1[ix] * g58[iy] * g4[iz];
s[373] = g0[ix] * g59[iy] * g4[iz];
s[374] = g0[ix] * g58[iy] * g5[iz];
s[375] = g1[ix] * g56[iy] * g6[iz];
s[376] = g0[ix] * g57[iy] * g6[iz];
s[377] = g0[ix] * g56[iy] * g7[iz];
s[378] = g7[ix] * g48[iy] * g8[iz];
s[379] = g6[ix] * g49[iy] * g8[iz];
s[380] = g6[ix] * g48[iy] * g9[iz];
s[381] = g5[ix] * g50[iy] * g8[iz];
s[382] = g4[ix] * g51[iy] * g8[iz];
s[383] = g4[ix] * g50[iy] * g9[iz];
s[384] = g5[ix] * g48[iy] * g10[iz];
s[385] = g4[ix] * g49[iy] * g10[iz];
s[386] = g4[ix] * g48[iy] * g11[iz];
s[387] = g3[ix] * g52[iy] * g8[iz];
s[388] = g2[ix] * g53[iy] * g8[iz];
s[389] = g2[ix] * g52[iy] * g9[iz];
s[390] = g1[ix] * g54[iy] * g8[iz];
s[391] = g0[ix] * g55[iy] * g8[iz];
s[392] = g0[ix] * g54[iy] * g9[iz];
s[393] = g1[ix] * g52[iy] * g10[iz];
s[394] = g0[ix] * g53[iy] * g10[iz];
s[395] = g0[ix] * g52[iy] * g11[iz];
s[396] = g3[ix] * g48[iy] * g12[iz];
s[397] = g2[ix] * g49[iy] * g12[iz];
s[398] = g2[ix] * g48[iy] * g13[iz];
s[399] = g1[ix] * g50[iy] * g12[iz];
s[400] = g0[ix] * g51[iy] * g12[iz];
s[401] = g0[ix] * g50[iy] * g13[iz];
s[402] = g1[ix] * g48[iy] * g14[iz];
s[403] = g0[ix] * g49[iy] * g14[iz];
s[404] = g0[ix] * g48[iy] * g15[iz];
s[405] = g15[ix] * g32[iy] * g16[iz];
s[406] = g14[ix] * g33[iy] * g16[iz];
s[407] = g14[ix] * g32[iy] * g17[iz];
s[408] = g13[ix] * g34[iy] * g16[iz];
s[409] = g12[ix] * g35[iy] * g16[iz];
s[410] = g12[ix] * g34[iy] * g17[iz];
s[411] = g13[ix] * g32[iy] * g18[iz];
s[412] = g12[ix] * g33[iy] * g18[iz];
s[413] = g12[ix] * g32[iy] * g19[iz];
s[414] = g11[ix] * g36[iy] * g16[iz];
s[415] = g10[ix] * g37[iy] * g16[iz];
s[416] = g10[ix] * g36[iy] * g17[iz];
s[417] = g9[ix] * g38[iy] * g16[iz];
s[418] = g8[ix] * g39[iy] * g16[iz];
s[419] = g8[ix] * g38[iy] * g17[iz];
s[420] = g9[ix] * g36[iy] * g18[iz];
s[421] = g8[ix] * g37[iy] * g18[iz];
s[422] = g8[ix] * g36[iy] * g19[iz];
s[423] = g11[ix] * g32[iy] * g20[iz];
s[424] = g10[ix] * g33[iy] * g20[iz];
s[425] = g10[ix] * g32[iy] * g21[iz];
s[426] = g9[ix] * g34[iy] * g20[iz];
s[427] = g8[ix] * g35[iy] * g20[iz];
s[428] = g8[ix] * g34[iy] * g21[iz];
s[429] = g9[ix] * g32[iy] * g22[iz];
s[430] = g8[ix] * g33[iy] * g22[iz];
s[431] = g8[ix] * g32[iy] * g23[iz];
s[432] = g7[ix] * g40[iy] * g16[iz];
s[433] = g6[ix] * g41[iy] * g16[iz];
s[434] = g6[ix] * g40[iy] * g17[iz];
s[435] = g5[ix] * g42[iy] * g16[iz];
s[436] = g4[ix] * g43[iy] * g16[iz];
s[437] = g4[ix] * g42[iy] * g17[iz];
s[438] = g5[ix] * g40[iy] * g18[iz];
s[439] = g4[ix] * g41[iy] * g18[iz];
s[440] = g4[ix] * g40[iy] * g19[iz];
s[441] = g3[ix] * g44[iy] * g16[iz];
s[442] = g2[ix] * g45[iy] * g16[iz];
s[443] = g2[ix] * g44[iy] * g17[iz];
s[444] = g1[ix] * g46[iy] * g16[iz];
s[445] = g0[ix] * g47[iy] * g16[iz];
s[446] = g0[ix] * g46[iy] * g17[iz];
s[447] = g1[ix] * g44[iy] * g18[iz];
s[448] = g0[ix] * g45[iy] * g18[iz];
s[449] = g0[ix] * g44[iy] * g19[iz];
s[450] = g3[ix] * g40[iy] * g20[iz];
s[451] = g2[ix] * g41[iy] * g20[iz];
s[452] = g2[ix] * g40[iy] * g21[iz];
s[453] = g1[ix] * g42[iy] * g20[iz];
s[454] = g0[ix] * g43[iy] * g20[iz];
s[455] = g0[ix] * g42[iy] * g21[iz];
s[456] = g1[ix] * g40[iy] * g22[iz];
s[457] = g0[ix] * g41[iy] * g22[iz];
s[458] = g0[ix] * g40[iy] * g23[iz];
s[459] = g7[ix] * g32[iy] * g24[iz];
s[460] = g6[ix] * g33[iy] * g24[iz];
s[461] = g6[ix] * g32[iy] * g25[iz];
s[462] = g5[ix] * g34[iy] * g24[iz];
s[463] = g4[ix] * g35[iy] * g24[iz];
s[464] = g4[ix] * g34[iy] * g25[iz];
s[465] = g5[ix] * g32[iy] * g26[iz];
s[466] = g4[ix] * g33[iy] * g26[iz];
s[467] = g4[ix] * g32[iy] * g27[iz];
s[468] = g3[ix] * g36[iy] * g24[iz];
s[469] = g2[ix] * g37[iy] * g24[iz];
s[470] = g2[ix] * g36[iy] * g25[iz];
s[471] = g1[ix] * g38[iy] * g24[iz];
s[472] = g0[ix] * g39[iy] * g24[iz];
s[473] = g0[ix] * g38[iy] * g25[iz];
s[474] = g1[ix] * g36[iy] * g26[iz];
s[475] = g0[ix] * g37[iy] * g26[iz];
s[476] = g0[ix] * g36[iy] * g27[iz];
s[477] = g3[ix] * g32[iy] * g28[iz];
s[478] = g2[ix] * g33[iy] * g28[iz];
s[479] = g2[ix] * g32[iy] * g29[iz];
s[480] = g1[ix] * g34[iy] * g28[iz];
s[481] = g0[ix] * g35[iy] * g28[iz];
s[482] = g0[ix] * g34[iy] * g29[iz];
s[483] = g1[ix] * g32[iy] * g30[iz];
s[484] = g0[ix] * g33[iy] * g30[iz];
s[485] = g0[ix] * g32[iy] * g31[iz];
s[486] = g31[ix] * g0[iy] * g32[iz];
s[487] = g30[ix] * g1[iy] * g32[iz];
s[488] = g30[ix] * g0[iy] * g33[iz];
s[489] = g29[ix] * g2[iy] * g32[iz];
s[490] = g28[ix] * g3[iy] * g32[iz];
s[491] = g28[ix] * g2[iy] * g33[iz];
s[492] = g29[ix] * g0[iy] * g34[iz];
s[493] = g28[ix] * g1[iy] * g34[iz];
s[494] = g28[ix] * g0[iy] * g35[iz];
s[495] = g27[ix] * g4[iy] * g32[iz];
s[496] = g26[ix] * g5[iy] * g32[iz];
s[497] = g26[ix] * g4[iy] * g33[iz];
s[498] = g25[ix] * g6[iy] * g32[iz];
s[499] = g24[ix] * g7[iy] * g32[iz];
s[500] = g24[ix] * g6[iy] * g33[iz];
s[501] = g25[ix] * g4[iy] * g34[iz];
s[502] = g24[ix] * g5[iy] * g34[iz];
s[503] = g24[ix] * g4[iy] * g35[iz];
s[504] = g27[ix] * g0[iy] * g36[iz];
s[505] = g26[ix] * g1[iy] * g36[iz];
s[506] = g26[ix] * g0[iy] * g37[iz];
s[507] = g25[ix] * g2[iy] * g36[iz];
s[508] = g24[ix] * g3[iy] * g36[iz];
s[509] = g24[ix] * g2[iy] * g37[iz];
s[510] = g25[ix] * g0[iy] * g38[iz];
s[511] = g24[ix] * g1[iy] * g38[iz];
s[512] = g24[ix] * g0[iy] * g39[iz];
s[513] = g23[ix] * g8[iy] * g32[iz];
s[514] = g22[ix] * g9[iy] * g32[iz];
s[515] = g22[ix] * g8[iy] * g33[iz];
s[516] = g21[ix] * g10[iy] * g32[iz];
s[517] = g20[ix] * g11[iy] * g32[iz];
s[518] = g20[ix] * g10[iy] * g33[iz];
s[519] = g21[ix] * g8[iy] * g34[iz];
s[520] = g20[ix] * g9[iy] * g34[iz];
s[521] = g20[ix] * g8[iy] * g35[iz];
s[522] = g19[ix] * g12[iy] * g32[iz];
s[523] = g18[ix] * g13[iy] * g32[iz];
s[524] = g18[ix] * g12[iy] * g33[iz];
s[525] = g17[ix] * g14[iy] * g32[iz];
s[526] = g16[ix] * g15[iy] * g32[iz];
s[527] = g16[ix] * g14[iy] * g33[iz];
s[528] = g17[ix] * g12[iy] * g34[iz];
s[529] = g16[ix] * g13[iy] * g34[iz];
s[530] = g16[ix] * g12[iy] * g35[iz];
s[531] = g19[ix] * g8[iy] * g36[iz];
s[532] = g18[ix] * g9[iy] * g36[iz];
s[533] = g18[ix] * g8[iy] * g37[iz];
s[534] = g17[ix] * g10[iy] * g36[iz];
s[535] = g16[ix] * g11[iy] * g36[iz];
s[536] = g16[ix] * g10[iy] * g37[iz];
s[537] = g17[ix] * g8[iy] * g38[iz];
s[538] = g16[ix] * g9[iy] * g38[iz];
s[539] = g16[ix] * g8[iy] * g39[iz];
s[540] = g23[ix] * g0[iy] * g40[iz];
s[541] = g22[ix] * g1[iy] * g40[iz];
s[542] = g22[ix] * g0[iy] * g41[iz];
s[543] = g21[ix] * g2[iy] * g40[iz];
s[544] = g20[ix] * g3[iy] * g40[iz];
s[545] = g20[ix] * g2[iy] * g41[iz];
s[546] = g21[ix] * g0[iy] * g42[iz];
s[547] = g20[ix] * g1[iy] * g42[iz];
s[548] = g20[ix] * g0[iy] * g43[iz];
s[549] = g19[ix] * g4[iy] * g40[iz];
s[550] = g18[ix] * g5[iy] * g40[iz];
s[551] = g18[ix] * g4[iy] * g41[iz];
s[552] = g17[ix] * g6[iy] * g40[iz];
s[553] = g16[ix] * g7[iy] * g40[iz];
s[554] = g16[ix] * g6[iy] * g41[iz];
s[555] = g17[ix] * g4[iy] * g42[iz];
s[556] = g16[ix] * g5[iy] * g42[iz];
s[557] = g16[ix] * g4[iy] * g43[iz];
s[558] = g19[ix] * g0[iy] * g44[iz];
s[559] = g18[ix] * g1[iy] * g44[iz];
s[560] = g18[ix] * g0[iy] * g45[iz];
s[561] = g17[ix] * g2[iy] * g44[iz];
s[562] = g16[ix] * g3[iy] * g44[iz];
s[563] = g16[ix] * g2[iy] * g45[iz];
s[564] = g17[ix] * g0[iy] * g46[iz];
s[565] = g16[ix] * g1[iy] * g46[iz];
s[566] = g16[ix] * g0[iy] * g47[iz];
s[567] = g15[ix] * g16[iy] * g32[iz];
s[568] = g14[ix] * g17[iy] * g32[iz];
s[569] = g14[ix] * g16[iy] * g33[iz];
s[570] = g13[ix] * g18[iy] * g32[iz];
s[571] = g12[ix] * g19[iy] * g32[iz];
s[572] = g12[ix] * g18[iy] * g33[iz];
s[573] = g13[ix] * g16[iy] * g34[iz];
s[574] = g12[ix] * g17[iy] * g34[iz];
s[575] = g12[ix] * g16[iy] * g35[iz];
s[576] = g11[ix] * g20[iy] * g32[iz];
s[577] = g10[ix] * g21[iy] * g32[iz];
s[578] = g10[ix] * g20[iy] * g33[iz];
s[579] = g9[ix] * g22[iy] * g32[iz];
s[580] = g8[ix] * g23[iy] * g32[iz];
s[581] = g8[ix] * g22[iy] * g33[iz];
s[582] = g9[ix] * g20[iy] * g34[iz];
s[583] = g8[ix] * g21[iy] * g34[iz];
s[584] = g8[ix] * g20[iy] * g35[iz];
s[585] = g11[ix] * g16[iy] * g36[iz];
s[586] = g10[ix] * g17[iy] * g36[iz];
s[587] = g10[ix] * g16[iy] * g37[iz];
s[588] = g9[ix] * g18[iy] * g36[iz];
s[589] = g8[ix] * g19[iy] * g36[iz];
s[590] = g8[ix] * g18[iy] * g37[iz];
s[591] = g9[ix] * g16[iy] * g38[iz];
s[592] = g8[ix] * g17[iy] * g38[iz];
s[593] = g8[ix] * g16[iy] * g39[iz];
s[594] = g7[ix] * g24[iy] * g32[iz];
s[595] = g6[ix] * g25[iy] * g32[iz];
s[596] = g6[ix] * g24[iy] * g33[iz];
s[597] = g5[ix] * g26[iy] * g32[iz];
s[598] = g4[ix] * g27[iy] * g32[iz];
s[599] = g4[ix] * g26[iy] * g33[iz];
s[600] = g5[ix] * g24[iy] * g34[iz];
s[601] = g4[ix] * g25[iy] * g34[iz];
s[602] = g4[ix] * g24[iy] * g35[iz];
s[603] = g3[ix] * g28[iy] * g32[iz];
s[604] = g2[ix] * g29[iy] * g32[iz];
s[605] = g2[ix] * g28[iy] * g33[iz];
s[606] = g1[ix] * g30[iy] * g32[iz];
s[607] = g0[ix] * g31[iy] * g32[iz];
s[608] = g0[ix] * g30[iy] * g33[iz];
s[609] = g1[ix] * g28[iy] * g34[iz];
s[610] = g0[ix] * g29[iy] * g34[iz];
s[611] = g0[ix] * g28[iy] * g35[iz];
s[612] = g3[ix] * g24[iy] * g36[iz];
s[613] = g2[ix] * g25[iy] * g36[iz];
s[614] = g2[ix] * g24[iy] * g37[iz];
s[615] = g1[ix] * g26[iy] * g36[iz];
s[616] = g0[ix] * g27[iy] * g36[iz];
s[617] = g0[ix] * g26[iy] * g37[iz];
s[618] = g1[ix] * g24[iy] * g38[iz];
s[619] = g0[ix] * g25[iy] * g38[iz];
s[620] = g0[ix] * g24[iy] * g39[iz];
s[621] = g7[ix] * g16[iy] * g40[iz];
s[622] = g6[ix] * g17[iy] * g40[iz];
s[623] = g6[ix] * g16[iy] * g41[iz];
s[624] = g5[ix] * g18[iy] * g40[iz];
s[625] = g4[ix] * g19[iy] * g40[iz];
s[626] = g4[ix] * g18[iy] * g41[iz];
s[627] = g5[ix] * g16[iy] * g42[iz];
s[628] = g4[ix] * g17[iy] * g42[iz];
s[629] = g4[ix] * g16[iy] * g43[iz];
s[630] = g3[ix] * g20[iy] * g40[iz];
s[631] = g2[ix] * g21[iy] * g40[iz];
s[632] = g2[ix] * g20[iy] * g41[iz];
s[633] = g1[ix] * g22[iy] * g40[iz];
s[634] = g0[ix] * g23[iy] * g40[iz];
s[635] = g0[ix] * g22[iy] * g41[iz];
s[636] = g1[ix] * g20[iy] * g42[iz];
s[637] = g0[ix] * g21[iy] * g42[iz];
s[638] = g0[ix] * g20[iy] * g43[iz];
s[639] = g3[ix] * g16[iy] * g44[iz];
s[640] = g2[ix] * g17[iy] * g44[iz];
s[641] = g2[ix] * g16[iy] * g45[iz];
s[642] = g1[ix] * g18[iy] * g44[iz];
s[643] = g0[ix] * g19[iy] * g44[iz];
s[644] = g0[ix] * g18[iy] * g45[iz];
s[645] = g1[ix] * g16[iy] * g46[iz];
s[646] = g0[ix] * g17[iy] * g46[iz];
s[647] = g0[ix] * g16[iy] * g47[iz];
s[648] = g15[ix] * g0[iy] * g48[iz];
s[649] = g14[ix] * g1[iy] * g48[iz];
s[650] = g14[ix] * g0[iy] * g49[iz];
s[651] = g13[ix] * g2[iy] * g48[iz];
s[652] = g12[ix] * g3[iy] * g48[iz];
s[653] = g12[ix] * g2[iy] * g49[iz];
s[654] = g13[ix] * g0[iy] * g50[iz];
s[655] = g12[ix] * g1[iy] * g50[iz];
s[656] = g12[ix] * g0[iy] * g51[iz];
s[657] = g11[ix] * g4[iy] * g48[iz];
s[658] = g10[ix] * g5[iy] * g48[iz];
s[659] = g10[ix] * g4[iy] * g49[iz];
s[660] = g9[ix] * g6[iy] * g48[iz];
s[661] = g8[ix] * g7[iy] * g48[iz];
s[662] = g8[ix] * g6[iy] * g49[iz];
s[663] = g9[ix] * g4[iy] * g50[iz];
s[664] = g8[ix] * g5[iy] * g50[iz];
s[665] = g8[ix] * g4[iy] * g51[iz];
s[666] = g11[ix] * g0[iy] * g52[iz];
s[667] = g10[ix] * g1[iy] * g52[iz];
s[668] = g10[ix] * g0[iy] * g53[iz];
s[669] = g9[ix] * g2[iy] * g52[iz];
s[670] = g8[ix] * g3[iy] * g52[iz];
s[671] = g8[ix] * g2[iy] * g53[iz];
s[672] = g9[ix] * g0[iy] * g54[iz];
s[673] = g8[ix] * g1[iy] * g54[iz];
s[674] = g8[ix] * g0[iy] * g55[iz];
s[675] = g7[ix] * g8[iy] * g48[iz];
s[676] = g6[ix] * g9[iy] * g48[iz];
s[677] = g6[ix] * g8[iy] * g49[iz];
s[678] = g5[ix] * g10[iy] * g48[iz];
s[679] = g4[ix] * g11[iy] * g48[iz];
s[680] = g4[ix] * g10[iy] * g49[iz];
s[681] = g5[ix] * g8[iy] * g50[iz];
s[682] = g4[ix] * g9[iy] * g50[iz];
s[683] = g4[ix] * g8[iy] * g51[iz];
s[684] = g3[ix] * g12[iy] * g48[iz];
s[685] = g2[ix] * g13[iy] * g48[iz];
s[686] = g2[ix] * g12[iy] * g49[iz];
s[687] = g1[ix] * g14[iy] * g48[iz];
s[688] = g0[ix] * g15[iy] * g48[iz];
s[689] = g0[ix] * g14[iy] * g49[iz];
s[690] = g1[ix] * g12[iy] * g50[iz];
s[691] = g0[ix] * g13[iy] * g50[iz];
s[692] = g0[ix] * g12[iy] * g51[iz];
s[693] = g3[ix] * g8[iy] * g52[iz];
s[694] = g2[ix] * g9[iy] * g52[iz];
s[695] = g2[ix] * g8[iy] * g53[iz];
s[696] = g1[ix] * g10[iy] * g52[iz];
s[697] = g0[ix] * g11[iy] * g52[iz];
s[698] = g0[ix] * g10[iy] * g53[iz];
s[699] = g1[ix] * g8[iy] * g54[iz];
s[700] = g0[ix] * g9[iy] * g54[iz];
s[701] = g0[ix] * g8[iy] * g55[iz];
s[702] = g7[ix] * g0[iy] * g56[iz];
s[703] = g6[ix] * g1[iy] * g56[iz];
s[704] = g6[ix] * g0[iy] * g57[iz];
s[705] = g5[ix] * g2[iy] * g56[iz];
s[706] = g4[ix] * g3[iy] * g56[iz];
s[707] = g4[ix] * g2[iy] * g57[iz];
s[708] = g5[ix] * g0[iy] * g58[iz];
s[709] = g4[ix] * g1[iy] * g58[iz];
s[710] = g4[ix] * g0[iy] * g59[iz];
s[711] = g3[ix] * g4[iy] * g56[iz];
s[712] = g2[ix] * g5[iy] * g56[iz];
s[713] = g2[ix] * g4[iy] * g57[iz];
s[714] = g1[ix] * g6[iy] * g56[iz];
s[715] = g0[ix] * g7[iy] * g56[iz];
s[716] = g0[ix] * g6[iy] * g57[iz];
s[717] = g1[ix] * g4[iy] * g58[iz];
s[718] = g0[ix] * g5[iy] * g58[iz];
s[719] = g0[ix] * g4[iy] * g59[iz];
s[720] = g3[ix] * g0[iy] * g60[iz];
s[721] = g2[ix] * g1[iy] * g60[iz];
s[722] = g2[ix] * g0[iy] * g61[iz];
s[723] = g1[ix] * g2[iy] * g60[iz];
s[724] = g0[ix] * g3[iy] * g60[iz];
s[725] = g0[ix] * g2[iy] * g61[iz];
s[726] = g1[ix] * g0[iy] * g62[iz];
s[727] = g0[ix] * g1[iy] * g62[iz];
s[728] = g0[ix] * g0[iy] * g63[iz];
if (gout_empty) {
gout[0] = + s[0] + (3*s[4]) + (3*s[8]) + (3*s[40]) + (6*s[44]) + (3*s[80]) + s[364] + (3*s[368]) + (3*s[404]) + s[728];
gout += 1;
} else {
gout[0] += + s[0] + (3*s[4]) + (3*s[8]) + (3*s[40]) + (6*s[44]) + (3*s[80]) + s[364] + (3*s[368]) + (3*s[404]) + s[728];
gout += 1;
}}}
void cint3c1e_r6_origk_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
*opt = NULL;
}
FINT cint3c1e_r6_origk_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {0, 0, 6, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int3c1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout3c1e_cint3c1e_r6_origk_sph;
envs.common_factor *= 1;
return CINT3c1e_spheric_drv(opijkl, &envs, opt, &c2s_sph_3c1e, 0);
}
OPTIMIZER2F_(cint3c1e_r6_origk_sph_optimizer);
C2Fo_(cint3c1e_r6_origk_sph)
