/*
 * Copyright (C) 2013-  Qiming Sun <osirpt.sun@gmail.com>
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include "cint_bas.h"
#include "cart2sph.h"
#include "g2e.h"
#include "g3c1e.h"
#include "g3c2e.h"
#include "g2c2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "fblas.h"
#include "c2f.h"
/* <i|OVLP |j> */
static void CINTgout1e_cint1e_ovlp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double s[1];
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g0[ix] * g0[iy] * g0[iz];
gout[0] += + s[0];
gout += 1;
}}
FINT cint1e_ovlp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ovlp_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_ovlp_sph)
/* <i|NUC |j> */
static void CINTgout1e_cint1e_nuc_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double s[1];
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g0[ix] * g0[iy] * g0[iz];
gout[0] += + s[0];
gout += 1;
}}
FINT cint1e_nuc_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_nuc_sph;
return CINT1e_nuc_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_nuc_sph)
/* <i|OVLP |P DOT P j> */
static void CINTgout1e_cint1e_kin_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+0, j_l+0);
G1E_D_J(g2, g0, i_l+0, j_l+1);
G1E_D_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + (-1*s[0]) + (-1*s[4]) + (-1*s[8]);
gout += 1;
}}
FINT cint1e_kin_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_kin_sph;
return CINT1e_drv(opij, &envs, 0.5, &c2s_sph_1e); }
C2F_(cint1e_kin_sph)
/* <i|NABLA-RINV |CROSS P j> */
static void CINTgout1e_cint1e_ia01p_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+0, j_l+0);
G1E_D_J(g2, g0, i_l+0, j_l+1);
G1E_D_I(g3, g0, i_l+0, j_l+1);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G1E_D_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}
FINT cint1e_ia01p_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ia01p_sph;
return CINT1e_rinv_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_ia01p_sph)
/* <i|OVLP |R CROSS P j> */
static void CINTgout1e_cint1e_giao_irjxp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+0, j_l+0);
G1E_R_J(g2, g0, i_l+0, j_l+1);
G1E_D_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}
FINT cint1e_giao_irjxp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_giao_irjxp_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_giao_irjxp_sph)
/* <i|OVLP |RC CROSS P j> */
static void CINTgout1e_cint1e_cg_irxp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_D_J(g1, g0, i_l+0, j_l+0);
G1E_RCJ(g2, g0, i_l+0, j_l+1);
G1E_D_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}
FINT cint1e_cg_irxp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_cg_irxp_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_cg_irxp_sph)
/* <i|NABLA-RINV |R j> */
static void CINTgout1e_cint1e_giao_a11part_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, i_l+0, j_l+0);
G1E_D_J(g2, g0, i_l+0, j_l+1);
G1E_D_I(g3, g0, i_l+0, j_l+1);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G1E_R_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout[3] += + s[3];
gout[4] += + s[4];
gout[5] += + s[5];
gout[6] += + s[6];
gout[7] += + s[7];
gout[8] += + s[8];
gout += 9;
}}
FINT cint1e_giao_a11part_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_giao_a11part_sph;
return CINT1e_rinv_drv(opij, &envs, -0.5, &c2s_sph_1e); }
C2F_(cint1e_giao_a11part_sph)
/* <i|NABLA-RINV |RC j> */
static void CINTgout1e_cint1e_cg_a11part_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
G1E_D_J(g2, g0, i_l+0, j_l+1);
G1E_D_I(g3, g0, i_l+0, j_l+1);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G1E_RCJ(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout[3] += + s[3];
gout[4] += + s[4];
gout[5] += + s[5];
gout[6] += + s[6];
gout[7] += + s[7];
gout[8] += + s[8];
gout += 9;
}}
FINT cint1e_cg_a11part_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_cg_a11part_sph;
return CINT1e_rinv_drv(opij, &envs, -0.5, &c2s_sph_1e); }
C2F_(cint1e_cg_a11part_sph)
/* <G i|NABLA-RINV CROSS P |j> */
static void CINTgout1e_cint1e_a01gp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double s[27];
double rirj[3], c[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_J(g2, g0, i_l+1, j_l+1);
G1E_D_I(g3, g0, i_l+1, j_l+1);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G1E_D_J(g3, g2, i_l+1, j_l+0);
G1E_R0I(g4, g0, i_l+0, j_l);
G1E_R0I(g5, g1, i_l+0, j_l);
G1E_R0I(g6, g2, i_l+0, j_l);
G1E_R0I(g7, g3, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g7[ix] * g0[iy] * g0[iz];
s[1] = g6[ix] * g1[iy] * g0[iz];
s[2] = g6[ix] * g0[iy] * g1[iz];
s[3] = g5[ix] * g2[iy] * g0[iz];
s[4] = g4[ix] * g3[iy] * g0[iz];
s[5] = g4[ix] * g2[iy] * g1[iz];
s[6] = g5[ix] * g0[iy] * g2[iz];
s[7] = g4[ix] * g1[iy] * g2[iz];
s[8] = g4[ix] * g0[iy] * g3[iz];
s[9] = g3[ix] * g4[iy] * g0[iz];
s[10] = g2[ix] * g5[iy] * g0[iz];
s[11] = g2[ix] * g4[iy] * g1[iz];
s[12] = g1[ix] * g6[iy] * g0[iz];
s[13] = g0[ix] * g7[iy] * g0[iz];
s[14] = g0[ix] * g6[iy] * g1[iz];
s[15] = g1[ix] * g4[iy] * g2[iz];
s[16] = g0[ix] * g5[iy] * g2[iz];
s[17] = g0[ix] * g4[iy] * g3[iz];
s[18] = g3[ix] * g0[iy] * g4[iz];
s[19] = g2[ix] * g1[iy] * g4[iz];
s[20] = g2[ix] * g0[iy] * g5[iz];
s[21] = g1[ix] * g2[iy] * g4[iz];
s[22] = g0[ix] * g3[iy] * g4[iz];
s[23] = g0[ix] * g2[iy] * g5[iz];
s[24] = g1[ix] * g0[iy] * g6[iz];
s[25] = g0[ix] * g1[iy] * g6[iz];
s[26] = g0[ix] * g0[iy] * g7[iz];
gout[0] += + c[1]*s[23] + (-1*c[2]*s[14]) + (-1*c[1]*s[25]) + c[2]*s[16];
gout[1] += + c[1]*s[24] + (-1*c[2]*s[15]) + (-1*c[1]*s[20]) + c[2]*s[11];
gout[2] += + c[1]*s[19] + (-1*c[2]*s[10]) + (-1*c[1]*s[21]) + c[2]*s[12];
gout[3] += + c[2]*s[5] + (-1*c[0]*s[23]) + (-1*c[2]*s[7]) + c[0]*s[25];
gout[4] += + c[2]*s[6] + (-1*c[0]*s[24]) + (-1*c[2]*s[2]) + c[0]*s[20];
gout[5] += + c[2]*s[1] + (-1*c[0]*s[19]) + (-1*c[2]*s[3]) + c[0]*s[21];
gout[6] += + c[0]*s[14] + (-1*c[1]*s[5]) + (-1*c[0]*s[16]) + c[1]*s[7];
gout[7] += + c[0]*s[15] + (-1*c[1]*s[6]) + (-1*c[0]*s[11]) + c[1]*s[2];
gout[8] += + c[0]*s[10] + (-1*c[1]*s[1]) + (-1*c[0]*s[12]) + c[1]*s[3];
gout += 9;
}}
FINT cint1e_a01gp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 0, 9};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT i_l = bas(ANG_OF, i_sh);
const FINT j_l = bas(ANG_OF, j_sh);if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (i_l * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (j_l * 2 + 1) * bas(NCTR_OF,j_sh);
CINTdset0(ip * jp * ng[TENSOR], opij);
return 0; }
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_a01gp_sph;
return CINT1e_rinv_drv(opij, &envs, 0.5, &c2s_sph_1e); }
C2F_(cint1e_a01gp_sph)
/* <G i|OVLP |P DOT P j> */
static void CINTgout1e_cint1e_igkin_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double s[27];
double rirj[3], c[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_J(g2, g0, i_l+1, j_l+1);
G1E_D_J(g3, g2, i_l+1, j_l+0);
G1E_R0I(g4, g0, i_l+0, j_l);
G1E_R0I(g5, g1, i_l+0, j_l);
G1E_R0I(g6, g2, i_l+0, j_l);
G1E_R0I(g7, g3, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g7[ix] * g0[iy] * g0[iz];
s[1] = g6[ix] * g1[iy] * g0[iz];
s[2] = g6[ix] * g0[iy] * g1[iz];
s[3] = g5[ix] * g2[iy] * g0[iz];
s[4] = g4[ix] * g3[iy] * g0[iz];
s[5] = g4[ix] * g2[iy] * g1[iz];
s[6] = g5[ix] * g0[iy] * g2[iz];
s[7] = g4[ix] * g1[iy] * g2[iz];
s[8] = g4[ix] * g0[iy] * g3[iz];
s[9] = g3[ix] * g4[iy] * g0[iz];
s[10] = g2[ix] * g5[iy] * g0[iz];
s[11] = g2[ix] * g4[iy] * g1[iz];
s[12] = g1[ix] * g6[iy] * g0[iz];
s[13] = g0[ix] * g7[iy] * g0[iz];
s[14] = g0[ix] * g6[iy] * g1[iz];
s[15] = g1[ix] * g4[iy] * g2[iz];
s[16] = g0[ix] * g5[iy] * g2[iz];
s[17] = g0[ix] * g4[iy] * g3[iz];
s[18] = g3[ix] * g0[iy] * g4[iz];
s[19] = g2[ix] * g1[iy] * g4[iz];
s[20] = g2[ix] * g0[iy] * g5[iz];
s[21] = g1[ix] * g2[iy] * g4[iz];
s[22] = g0[ix] * g3[iy] * g4[iz];
s[23] = g0[ix] * g2[iy] * g5[iz];
s[24] = g1[ix] * g0[iy] * g6[iz];
s[25] = g0[ix] * g1[iy] * g6[iz];
s[26] = g0[ix] * g0[iy] * g7[iz];
gout[0] += + c[1]*s[18] + (-1*c[2]*s[9]) + c[1]*s[22] + (-1*c[2]*s[13]) + c[1]*s[26] + (-1*c[2]*s[17]);
gout[1] += + c[2]*s[0] + (-1*c[0]*s[18]) + c[2]*s[4] + (-1*c[0]*s[22]) + c[2]*s[8] + (-1*c[0]*s[26]);
gout[2] += + c[0]*s[9] + (-1*c[1]*s[0]) + c[0]*s[13] + (-1*c[1]*s[4]) + c[0]*s[17] + (-1*c[1]*s[8]);
gout += 3;
}}
FINT cint1e_igkin_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 0, 3};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT i_l = bas(ANG_OF, i_sh);
const FINT j_l = bas(ANG_OF, j_sh);if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (i_l * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (j_l * 2 + 1) * bas(NCTR_OF,j_sh);
CINTdset0(ip * jp * ng[TENSOR], opij);
return 0; }
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_igkin_sph;
return CINT1e_drv(opij, &envs, 0.25, &c2s_sph_1e); }
C2F_(cint1e_igkin_sph)
/* <G i|OVLP |j> */
static void CINTgout1e_cint1e_igovlp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
double rirj[3], c[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G1E_R0I(g1, g0, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + (-1*c[1]*s[2]) + c[2]*s[1];
gout[1] += + (-1*c[2]*s[0]) + c[0]*s[2];
gout[2] += + (-1*c[0]*s[1]) + c[1]*s[0];
gout += 3;
}}
FINT cint1e_igovlp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT i_l = bas(ANG_OF, i_sh);
const FINT j_l = bas(ANG_OF, j_sh);if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (i_l * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (j_l * 2 + 1) * bas(NCTR_OF,j_sh);
CINTdset0(ip * jp * ng[TENSOR], opij);
return 0; }
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_igovlp_sph;
return CINT1e_drv(opij, &envs, 0.5, &c2s_sph_1e); }
C2F_(cint1e_igovlp_sph)
/* <G i|NUC |j> */
static void CINTgout1e_cint1e_ignuc_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
double rirj[3], c[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G1E_R0I(g1, g0, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + (-1*c[1]*s[2]) + c[2]*s[1];
gout[1] += + (-1*c[2]*s[0]) + c[0]*s[2];
gout[2] += + (-1*c[0]*s[1]) + c[1]*s[0];
gout += 3;
}}
FINT cint1e_ignuc_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT i_l = bas(ANG_OF, i_sh);
const FINT j_l = bas(ANG_OF, j_sh);if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (i_l * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (j_l * 2 + 1) * bas(NCTR_OF,j_sh);
CINTdset0(ip * jp * ng[TENSOR], opij);
return 0; }
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ignuc_sph;
return CINT1e_nuc_drv(opij, &envs, 0.5, &c2s_sph_1e); }
C2F_(cint1e_ignuc_sph)
/* <P* i|NUC DOT P |j> */
static void CINTgout1e_cint1e_pnucp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_I(g2, g0, i_l+0, j_l);
G1E_D_I(g3, g1, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0] + s[4] + s[8];
gout += 1;
}}
FINT cint1e_pnucp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_pnucp_sph;
return CINT1e_nuc_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_pnucp_sph)
/* <i|ZC |j> */
static void CINTgout1e_cint1e_z_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[2];
gout += 1;
}}
FINT cint1e_z_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_z_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_z_sph)
/* <i|ZC ZC |j> */
static void CINTgout1e_cint1e_zz_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
G1E_RCJ(g2, g0, i_l+0, j_l+1);
G1E_RCJ(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[8];
gout += 1;
}}
FINT cint1e_zz_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_zz_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_zz_sph)
/* <i|RC |j> */
static void CINTgout1e_cint1e_r_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}
FINT cint1e_r_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r_sph)
/* <i|RC DOT RC |j> */
static void CINTgout1e_cint1e_r2_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
G1E_RCJ(g2, g0, i_l+0, j_l+1);
G1E_RCJ(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0] + s[4] + s[8];
gout += 1;
}}
FINT cint1e_r2_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r2_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r2_sph)
/* <i|RC RC |j> */
static void CINTgout1e_cint1e_rr_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
double drj[3];
drj[0] = rj[0] - env[PTR_COMMON_ORIG+0];
drj[1] = rj[1] - env[PTR_COMMON_ORIG+1];
drj[2] = rj[2] - env[PTR_COMMON_ORIG+2];
G1E_RCJ(g1, g0, i_l+0, j_l+0);
G1E_RCJ(g2, g0, i_l+0, j_l+1);
G1E_RCJ(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout[3] += + s[3];
gout[4] += + s[4];
gout[5] += + s[5];
gout[6] += + s[6];
gout[7] += + s[7];
gout[8] += + s[8];
gout += 9;
}}
FINT cint1e_rr_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_rr_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_rr_sph)
/* <i|Z |j> */
static void CINTgout1e_cint1e_z_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
G1E_R_J(g1, g0, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[2];
gout += 1;
}}
FINT cint1e_z_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_z_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_z_origj_sph)
/* <i|Z Z |j> */
static void CINTgout1e_cint1e_zz_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, i_l+0, j_l+0);
G1E_R_J(g2, g0, i_l+0, j_l+1);
G1E_R_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[8];
gout += 1;
}}
FINT cint1e_zz_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_zz_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_zz_origj_sph)
/* <i|R |j> */
static void CINTgout1e_cint1e_r_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
G1E_R_J(g1, g0, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}
FINT cint1e_r_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r_origj_sph)
/* <i|R R |j> */
static void CINTgout1e_cint1e_rr_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, i_l+0, j_l+0);
G1E_R_J(g2, g0, i_l+0, j_l+1);
G1E_R_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout[3] += + s[3];
gout[4] += + s[4];
gout[5] += + s[5];
gout[6] += + s[6];
gout[7] += + s[7];
gout[8] += + s[8];
gout += 9;
}}
FINT cint1e_rr_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_rr_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_rr_origj_sph)
/* <i|R DOT R |j> */
static void CINTgout1e_cint1e_r2_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, i_l+0, j_l+0);
G1E_R_J(g2, g0, i_l+0, j_l+1);
G1E_R_J(g3, g2, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0] + s[4] + s[8];
gout += 1;
}}
FINT cint1e_r2_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r2_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r2_origj_sph)
/* <i|OVLP |R DOT R R DOT R j> */
static void CINTgout1e_cint1e_r4_origj_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double *g9 = g8  + envs->g_size * 3;
double *g10 = g9  + envs->g_size * 3;
double *g11 = g10  + envs->g_size * 3;
double *g12 = g11  + envs->g_size * 3;
double *g13 = g12  + envs->g_size * 3;
double *g14 = g13  + envs->g_size * 3;
double *g15 = g14  + envs->g_size * 3;
double *g16 = g15  + envs->g_size * 3;
double s[81];
G1E_R_J(g1, g0, i_l+0, j_l+0);
G1E_R_J(g2, g0, i_l+0, j_l+1);
G1E_R_J(g3, g2, i_l+0, j_l+0);
G1E_R_J(g4, g0, i_l+0, j_l+2);
G1E_R_J(g5, g4, i_l+0, j_l+0);
G1E_R_J(g6, g4, i_l+0, j_l+1);
G1E_R_J(g7, g6, i_l+0, j_l+0);
G1E_R_J(g8, g0, i_l+0, j_l+3);
G1E_R_J(g9, g8, i_l+0, j_l+0);
G1E_R_J(g10, g8, i_l+0, j_l+1);
G1E_R_J(g11, g10, i_l+0, j_l+0);
G1E_R_J(g12, g8, i_l+0, j_l+2);
G1E_R_J(g13, g12, i_l+0, j_l+0);
G1E_R_J(g14, g12, i_l+0, j_l+1);
G1E_R_J(g15, g14, i_l+0, j_l+0);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g15[ix] * g0[iy] * g0[iz];
s[1] = g14[ix] * g1[iy] * g0[iz];
s[2] = g14[ix] * g0[iy] * g1[iz];
s[3] = g13[ix] * g2[iy] * g0[iz];
s[4] = g12[ix] * g3[iy] * g0[iz];
s[5] = g12[ix] * g2[iy] * g1[iz];
s[6] = g13[ix] * g0[iy] * g2[iz];
s[7] = g12[ix] * g1[iy] * g2[iz];
s[8] = g12[ix] * g0[iy] * g3[iz];
s[9] = g11[ix] * g4[iy] * g0[iz];
s[10] = g10[ix] * g5[iy] * g0[iz];
s[11] = g10[ix] * g4[iy] * g1[iz];
s[12] = g9[ix] * g6[iy] * g0[iz];
s[13] = g8[ix] * g7[iy] * g0[iz];
s[14] = g8[ix] * g6[iy] * g1[iz];
s[15] = g9[ix] * g4[iy] * g2[iz];
s[16] = g8[ix] * g5[iy] * g2[iz];
s[17] = g8[ix] * g4[iy] * g3[iz];
s[18] = g11[ix] * g0[iy] * g4[iz];
s[19] = g10[ix] * g1[iy] * g4[iz];
s[20] = g10[ix] * g0[iy] * g5[iz];
s[21] = g9[ix] * g2[iy] * g4[iz];
s[22] = g8[ix] * g3[iy] * g4[iz];
s[23] = g8[ix] * g2[iy] * g5[iz];
s[24] = g9[ix] * g0[iy] * g6[iz];
s[25] = g8[ix] * g1[iy] * g6[iz];
s[26] = g8[ix] * g0[iy] * g7[iz];
s[27] = g7[ix] * g8[iy] * g0[iz];
s[28] = g6[ix] * g9[iy] * g0[iz];
s[29] = g6[ix] * g8[iy] * g1[iz];
s[30] = g5[ix] * g10[iy] * g0[iz];
s[31] = g4[ix] * g11[iy] * g0[iz];
s[32] = g4[ix] * g10[iy] * g1[iz];
s[33] = g5[ix] * g8[iy] * g2[iz];
s[34] = g4[ix] * g9[iy] * g2[iz];
s[35] = g4[ix] * g8[iy] * g3[iz];
s[36] = g3[ix] * g12[iy] * g0[iz];
s[37] = g2[ix] * g13[iy] * g0[iz];
s[38] = g2[ix] * g12[iy] * g1[iz];
s[39] = g1[ix] * g14[iy] * g0[iz];
s[40] = g0[ix] * g15[iy] * g0[iz];
s[41] = g0[ix] * g14[iy] * g1[iz];
s[42] = g1[ix] * g12[iy] * g2[iz];
s[43] = g0[ix] * g13[iy] * g2[iz];
s[44] = g0[ix] * g12[iy] * g3[iz];
s[45] = g3[ix] * g8[iy] * g4[iz];
s[46] = g2[ix] * g9[iy] * g4[iz];
s[47] = g2[ix] * g8[iy] * g5[iz];
s[48] = g1[ix] * g10[iy] * g4[iz];
s[49] = g0[ix] * g11[iy] * g4[iz];
s[50] = g0[ix] * g10[iy] * g5[iz];
s[51] = g1[ix] * g8[iy] * g6[iz];
s[52] = g0[ix] * g9[iy] * g6[iz];
s[53] = g0[ix] * g8[iy] * g7[iz];
s[54] = g7[ix] * g0[iy] * g8[iz];
s[55] = g6[ix] * g1[iy] * g8[iz];
s[56] = g6[ix] * g0[iy] * g9[iz];
s[57] = g5[ix] * g2[iy] * g8[iz];
s[58] = g4[ix] * g3[iy] * g8[iz];
s[59] = g4[ix] * g2[iy] * g9[iz];
s[60] = g5[ix] * g0[iy] * g10[iz];
s[61] = g4[ix] * g1[iy] * g10[iz];
s[62] = g4[ix] * g0[iy] * g11[iz];
s[63] = g3[ix] * g4[iy] * g8[iz];
s[64] = g2[ix] * g5[iy] * g8[iz];
s[65] = g2[ix] * g4[iy] * g9[iz];
s[66] = g1[ix] * g6[iy] * g8[iz];
s[67] = g0[ix] * g7[iy] * g8[iz];
s[68] = g0[ix] * g6[iy] * g9[iz];
s[69] = g1[ix] * g4[iy] * g10[iz];
s[70] = g0[ix] * g5[iy] * g10[iz];
s[71] = g0[ix] * g4[iy] * g11[iz];
s[72] = g3[ix] * g0[iy] * g12[iz];
s[73] = g2[ix] * g1[iy] * g12[iz];
s[74] = g2[ix] * g0[iy] * g13[iz];
s[75] = g1[ix] * g2[iy] * g12[iz];
s[76] = g0[ix] * g3[iy] * g12[iz];
s[77] = g0[ix] * g2[iy] * g13[iz];
s[78] = g1[ix] * g0[iy] * g14[iz];
s[79] = g0[ix] * g1[iy] * g14[iz];
s[80] = g0[ix] * g0[iy] * g15[iz];
gout[0] += + s[0] + (2*s[4]) + (2*s[8]) + s[40] + (2*s[44]) + s[80];
gout += 1;
}}
FINT cint1e_r4_origj_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r4_origj_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r4_origj_sph)
/* <R DOT R i|OVLP |j> */
static void CINTgout1e_cint1e_r2_origi_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_R_I(g1, g0, i_l+1, j_l);
G1E_R_I(g2, g0, i_l+0, j_l);
G1E_R_I(g3, g1, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[0] + s[4] + s[8];
gout += 1;
}}
FINT cint1e_r2_origi_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r2_origi_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r2_origi_sph)
/* <R DOT R R DOT R i|OVLP |j> */
static void CINTgout1e_cint1e_r4_origi_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double *g9 = g8  + envs->g_size * 3;
double *g10 = g9  + envs->g_size * 3;
double *g11 = g10  + envs->g_size * 3;
double *g12 = g11  + envs->g_size * 3;
double *g13 = g12  + envs->g_size * 3;
double *g14 = g13  + envs->g_size * 3;
double *g15 = g14  + envs->g_size * 3;
double *g16 = g15  + envs->g_size * 3;
double s[81];
G1E_R_I(g1, g0, i_l+3, j_l);
G1E_R_I(g2, g0, i_l+2, j_l);
G1E_R_I(g3, g1, i_l+2, j_l);
G1E_R_I(g4, g0, i_l+1, j_l);
G1E_R_I(g5, g1, i_l+1, j_l);
G1E_R_I(g6, g2, i_l+1, j_l);
G1E_R_I(g7, g3, i_l+1, j_l);
G1E_R_I(g8, g0, i_l+0, j_l);
G1E_R_I(g9, g1, i_l+0, j_l);
G1E_R_I(g10, g2, i_l+0, j_l);
G1E_R_I(g11, g3, i_l+0, j_l);
G1E_R_I(g12, g4, i_l+0, j_l);
G1E_R_I(g13, g5, i_l+0, j_l);
G1E_R_I(g14, g6, i_l+0, j_l);
G1E_R_I(g15, g7, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g15[ix] * g0[iy] * g0[iz];
s[1] = g14[ix] * g1[iy] * g0[iz];
s[2] = g14[ix] * g0[iy] * g1[iz];
s[3] = g13[ix] * g2[iy] * g0[iz];
s[4] = g12[ix] * g3[iy] * g0[iz];
s[5] = g12[ix] * g2[iy] * g1[iz];
s[6] = g13[ix] * g0[iy] * g2[iz];
s[7] = g12[ix] * g1[iy] * g2[iz];
s[8] = g12[ix] * g0[iy] * g3[iz];
s[9] = g11[ix] * g4[iy] * g0[iz];
s[10] = g10[ix] * g5[iy] * g0[iz];
s[11] = g10[ix] * g4[iy] * g1[iz];
s[12] = g9[ix] * g6[iy] * g0[iz];
s[13] = g8[ix] * g7[iy] * g0[iz];
s[14] = g8[ix] * g6[iy] * g1[iz];
s[15] = g9[ix] * g4[iy] * g2[iz];
s[16] = g8[ix] * g5[iy] * g2[iz];
s[17] = g8[ix] * g4[iy] * g3[iz];
s[18] = g11[ix] * g0[iy] * g4[iz];
s[19] = g10[ix] * g1[iy] * g4[iz];
s[20] = g10[ix] * g0[iy] * g5[iz];
s[21] = g9[ix] * g2[iy] * g4[iz];
s[22] = g8[ix] * g3[iy] * g4[iz];
s[23] = g8[ix] * g2[iy] * g5[iz];
s[24] = g9[ix] * g0[iy] * g6[iz];
s[25] = g8[ix] * g1[iy] * g6[iz];
s[26] = g8[ix] * g0[iy] * g7[iz];
s[27] = g7[ix] * g8[iy] * g0[iz];
s[28] = g6[ix] * g9[iy] * g0[iz];
s[29] = g6[ix] * g8[iy] * g1[iz];
s[30] = g5[ix] * g10[iy] * g0[iz];
s[31] = g4[ix] * g11[iy] * g0[iz];
s[32] = g4[ix] * g10[iy] * g1[iz];
s[33] = g5[ix] * g8[iy] * g2[iz];
s[34] = g4[ix] * g9[iy] * g2[iz];
s[35] = g4[ix] * g8[iy] * g3[iz];
s[36] = g3[ix] * g12[iy] * g0[iz];
s[37] = g2[ix] * g13[iy] * g0[iz];
s[38] = g2[ix] * g12[iy] * g1[iz];
s[39] = g1[ix] * g14[iy] * g0[iz];
s[40] = g0[ix] * g15[iy] * g0[iz];
s[41] = g0[ix] * g14[iy] * g1[iz];
s[42] = g1[ix] * g12[iy] * g2[iz];
s[43] = g0[ix] * g13[iy] * g2[iz];
s[44] = g0[ix] * g12[iy] * g3[iz];
s[45] = g3[ix] * g8[iy] * g4[iz];
s[46] = g2[ix] * g9[iy] * g4[iz];
s[47] = g2[ix] * g8[iy] * g5[iz];
s[48] = g1[ix] * g10[iy] * g4[iz];
s[49] = g0[ix] * g11[iy] * g4[iz];
s[50] = g0[ix] * g10[iy] * g5[iz];
s[51] = g1[ix] * g8[iy] * g6[iz];
s[52] = g0[ix] * g9[iy] * g6[iz];
s[53] = g0[ix] * g8[iy] * g7[iz];
s[54] = g7[ix] * g0[iy] * g8[iz];
s[55] = g6[ix] * g1[iy] * g8[iz];
s[56] = g6[ix] * g0[iy] * g9[iz];
s[57] = g5[ix] * g2[iy] * g8[iz];
s[58] = g4[ix] * g3[iy] * g8[iz];
s[59] = g4[ix] * g2[iy] * g9[iz];
s[60] = g5[ix] * g0[iy] * g10[iz];
s[61] = g4[ix] * g1[iy] * g10[iz];
s[62] = g4[ix] * g0[iy] * g11[iz];
s[63] = g3[ix] * g4[iy] * g8[iz];
s[64] = g2[ix] * g5[iy] * g8[iz];
s[65] = g2[ix] * g4[iy] * g9[iz];
s[66] = g1[ix] * g6[iy] * g8[iz];
s[67] = g0[ix] * g7[iy] * g8[iz];
s[68] = g0[ix] * g6[iy] * g9[iz];
s[69] = g1[ix] * g4[iy] * g10[iz];
s[70] = g0[ix] * g5[iy] * g10[iz];
s[71] = g0[ix] * g4[iy] * g11[iz];
s[72] = g3[ix] * g0[iy] * g12[iz];
s[73] = g2[ix] * g1[iy] * g12[iz];
s[74] = g2[ix] * g0[iy] * g13[iz];
s[75] = g1[ix] * g2[iy] * g12[iz];
s[76] = g0[ix] * g3[iy] * g12[iz];
s[77] = g0[ix] * g2[iy] * g13[iz];
s[78] = g1[ix] * g0[iy] * g14[iz];
s[79] = g0[ix] * g1[iy] * g14[iz];
s[80] = g0[ix] * g0[iy] * g15[iz];
gout[0] += + s[0] + (2*s[4]) + (2*s[8]) + s[40] + (2*s[44]) + s[80];
gout += 1;
}}
FINT cint1e_r4_origi_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_r4_origi_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_r4_origi_sph)
/* <P DOT P i|OVLP |P DOT P j> */
static void CINTgout1e_cint1e_p4_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double *g9 = g8  + envs->g_size * 3;
double *g10 = g9  + envs->g_size * 3;
double *g11 = g10  + envs->g_size * 3;
double *g12 = g11  + envs->g_size * 3;
double *g13 = g12  + envs->g_size * 3;
double *g14 = g13  + envs->g_size * 3;
double *g15 = g14  + envs->g_size * 3;
double *g16 = g15  + envs->g_size * 3;
double s[81];
G1E_D_J(g1, g0, i_l+2, j_l+0);
G1E_D_J(g2, g0, i_l+2, j_l+1);
G1E_D_J(g3, g2, i_l+2, j_l+0);
G1E_D_I(g4, g0, i_l+1, j_l);
G1E_D_I(g5, g1, i_l+1, j_l);
G1E_D_I(g6, g2, i_l+1, j_l);
G1E_D_I(g7, g3, i_l+1, j_l);
G1E_D_I(g8, g0, i_l+0, j_l);
G1E_D_I(g9, g1, i_l+0, j_l);
G1E_D_I(g10, g2, i_l+0, j_l);
G1E_D_I(g11, g3, i_l+0, j_l);
G1E_D_I(g12, g4, i_l+0, j_l);
G1E_D_I(g13, g5, i_l+0, j_l);
G1E_D_I(g14, g6, i_l+0, j_l);
G1E_D_I(g15, g7, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g15[ix] * g0[iy] * g0[iz];
s[1] = g14[ix] * g1[iy] * g0[iz];
s[2] = g14[ix] * g0[iy] * g1[iz];
s[3] = g13[ix] * g2[iy] * g0[iz];
s[4] = g12[ix] * g3[iy] * g0[iz];
s[5] = g12[ix] * g2[iy] * g1[iz];
s[6] = g13[ix] * g0[iy] * g2[iz];
s[7] = g12[ix] * g1[iy] * g2[iz];
s[8] = g12[ix] * g0[iy] * g3[iz];
s[9] = g11[ix] * g4[iy] * g0[iz];
s[10] = g10[ix] * g5[iy] * g0[iz];
s[11] = g10[ix] * g4[iy] * g1[iz];
s[12] = g9[ix] * g6[iy] * g0[iz];
s[13] = g8[ix] * g7[iy] * g0[iz];
s[14] = g8[ix] * g6[iy] * g1[iz];
s[15] = g9[ix] * g4[iy] * g2[iz];
s[16] = g8[ix] * g5[iy] * g2[iz];
s[17] = g8[ix] * g4[iy] * g3[iz];
s[18] = g11[ix] * g0[iy] * g4[iz];
s[19] = g10[ix] * g1[iy] * g4[iz];
s[20] = g10[ix] * g0[iy] * g5[iz];
s[21] = g9[ix] * g2[iy] * g4[iz];
s[22] = g8[ix] * g3[iy] * g4[iz];
s[23] = g8[ix] * g2[iy] * g5[iz];
s[24] = g9[ix] * g0[iy] * g6[iz];
s[25] = g8[ix] * g1[iy] * g6[iz];
s[26] = g8[ix] * g0[iy] * g7[iz];
s[27] = g7[ix] * g8[iy] * g0[iz];
s[28] = g6[ix] * g9[iy] * g0[iz];
s[29] = g6[ix] * g8[iy] * g1[iz];
s[30] = g5[ix] * g10[iy] * g0[iz];
s[31] = g4[ix] * g11[iy] * g0[iz];
s[32] = g4[ix] * g10[iy] * g1[iz];
s[33] = g5[ix] * g8[iy] * g2[iz];
s[34] = g4[ix] * g9[iy] * g2[iz];
s[35] = g4[ix] * g8[iy] * g3[iz];
s[36] = g3[ix] * g12[iy] * g0[iz];
s[37] = g2[ix] * g13[iy] * g0[iz];
s[38] = g2[ix] * g12[iy] * g1[iz];
s[39] = g1[ix] * g14[iy] * g0[iz];
s[40] = g0[ix] * g15[iy] * g0[iz];
s[41] = g0[ix] * g14[iy] * g1[iz];
s[42] = g1[ix] * g12[iy] * g2[iz];
s[43] = g0[ix] * g13[iy] * g2[iz];
s[44] = g0[ix] * g12[iy] * g3[iz];
s[45] = g3[ix] * g8[iy] * g4[iz];
s[46] = g2[ix] * g9[iy] * g4[iz];
s[47] = g2[ix] * g8[iy] * g5[iz];
s[48] = g1[ix] * g10[iy] * g4[iz];
s[49] = g0[ix] * g11[iy] * g4[iz];
s[50] = g0[ix] * g10[iy] * g5[iz];
s[51] = g1[ix] * g8[iy] * g6[iz];
s[52] = g0[ix] * g9[iy] * g6[iz];
s[53] = g0[ix] * g8[iy] * g7[iz];
s[54] = g7[ix] * g0[iy] * g8[iz];
s[55] = g6[ix] * g1[iy] * g8[iz];
s[56] = g6[ix] * g0[iy] * g9[iz];
s[57] = g5[ix] * g2[iy] * g8[iz];
s[58] = g4[ix] * g3[iy] * g8[iz];
s[59] = g4[ix] * g2[iy] * g9[iz];
s[60] = g5[ix] * g0[iy] * g10[iz];
s[61] = g4[ix] * g1[iy] * g10[iz];
s[62] = g4[ix] * g0[iy] * g11[iz];
s[63] = g3[ix] * g4[iy] * g8[iz];
s[64] = g2[ix] * g5[iy] * g8[iz];
s[65] = g2[ix] * g4[iy] * g9[iz];
s[66] = g1[ix] * g6[iy] * g8[iz];
s[67] = g0[ix] * g7[iy] * g8[iz];
s[68] = g0[ix] * g6[iy] * g9[iz];
s[69] = g1[ix] * g4[iy] * g10[iz];
s[70] = g0[ix] * g5[iy] * g10[iz];
s[71] = g0[ix] * g4[iy] * g11[iz];
s[72] = g3[ix] * g0[iy] * g12[iz];
s[73] = g2[ix] * g1[iy] * g12[iz];
s[74] = g2[ix] * g0[iy] * g13[iz];
s[75] = g1[ix] * g2[iy] * g12[iz];
s[76] = g0[ix] * g3[iy] * g12[iz];
s[77] = g0[ix] * g2[iy] * g13[iz];
s[78] = g1[ix] * g0[iy] * g14[iz];
s[79] = g0[ix] * g1[iy] * g14[iz];
s[80] = g0[ix] * g0[iy] * g15[iz];
gout[0] += + s[0] + (2*s[4]) + (2*s[8]) + s[40] + (2*s[44]) + s[80];
gout += 1;
}}
FINT cint1e_p4_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_p4_sph;
return CINT1e_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_p4_sph)
/* <P* i|RINV CROSS P |j> */
static void CINTgout1e_cint1e_prinvxp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_I(g2, g0, i_l+0, j_l);
G1E_D_I(g3, g1, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}
FINT cint1e_prinvxp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_prinvxp_sph;
return CINT1e_rinv_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_prinvxp_sph)
/* <P* i|NUC CROSS P |j> */
static void CINTgout1e_cint1e_pnucxp_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_I(g2, g0, i_l+0, j_l);
G1E_D_I(g3, g1, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g3[ix] * g0[iy] * g0[iz];
s[1] = g2[ix] * g1[iy] * g0[iz];
s[2] = g2[ix] * g0[iy] * g1[iz];
s[3] = g1[ix] * g2[iy] * g0[iz];
s[4] = g0[ix] * g3[iy] * g0[iz];
s[5] = g0[ix] * g2[iy] * g1[iz];
s[6] = g1[ix] * g0[iy] * g2[iz];
s[7] = g0[ix] * g1[iy] * g2[iz];
s[8] = g0[ix] * g0[iy] * g3[iz];
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}
FINT cint1e_pnucxp_sph(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_pnucxp_sph;
return CINT1e_nuc_drv(opij, &envs, 1, &c2s_sph_1e); }
C2F_(cint1e_pnucxp_sph)
/* <k P* i|R12 |CROSS P j l> : i,j \in electron 1; k,l \in electron 2
 * = (P* i CROSS P j|R12 |k l) */
static void CINTgout2e_cint2e_p1vxp1_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double s[9];
G2E_D_J(g1, g0, i_l+1, j_l+0, k_l, l_l);
G2E_D_I(g2, g0, i_l+0, j_l, k_l, l_l);
G2E_D_I(g3, g1, i_l+0, j_l, k_l, l_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(9, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[0] = + s[5] + (-1*s[7]);
gout[1] = + s[6] + (-1*s[2]);
gout[2] = + s[1] + (-1*s[3]);
gout += 3;
} else {
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout += 3;
}}}
void cint2e_p1vxp1_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_p1vxp1_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_p1vxp1_sph;
envs.common_factor *= 1;
return CINT2e_spheric_drv(opijkl, &envs, opt);
}
OPTIMIZER2F_(cint2e_p1vxp1_sph_optimizer);
C2Fo_(cint2e_p1vxp1_sph)
/* <k G i|R12 |j l> : i,j \in electron 1; k,l \in electron 2
 * = (G i j|R12 |k l) */
static void CINTgout2e_cint2e_ig1_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double s[3];
double rirj[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
double c[3];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G2E_R0I(g1, g0, i_l+0, j_l, k_l, l_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
switch (envs->nrys_roots) {
case 1:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
break;
case 2:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1];
break;
case 3:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2];
break;
case 4:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3];
break;
case 5:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3]+ g1[ix+4]*g0[iy+4]*g0[iz+4];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3]+ g0[ix+4]*g1[iy+4]*g0[iz+4];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3]+ g0[ix+4]*g0[iy+4]*g1[iz+4];
break;
case 6:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3]+ g1[ix+4]*g0[iy+4]*g0[iz+4]+ g1[ix+5]*g0[iy+5]*g0[iz+5];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3]+ g0[ix+4]*g1[iy+4]*g0[iz+4]+ g0[ix+5]*g1[iy+5]*g0[iz+5];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3]+ g0[ix+4]*g0[iy+4]*g1[iz+4]+ g0[ix+5]*g0[iy+5]*g1[iz+5];
break;
case 7:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3]+ g1[ix+4]*g0[iy+4]*g0[iz+4]+ g1[ix+5]*g0[iy+5]*g0[iz+5]+ g1[ix+6]*g0[iy+6]*g0[iz+6];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3]+ g0[ix+4]*g1[iy+4]*g0[iz+4]+ g0[ix+5]*g1[iy+5]*g0[iz+5]+ g0[ix+6]*g1[iy+6]*g0[iz+6];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3]+ g0[ix+4]*g0[iy+4]*g1[iz+4]+ g0[ix+5]*g0[iy+5]*g1[iz+5]+ g0[ix+6]*g0[iy+6]*g1[iz+6];
break;
case 8:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3]+ g1[ix+4]*g0[iy+4]*g0[iz+4]+ g1[ix+5]*g0[iy+5]*g0[iz+5]+ g1[ix+6]*g0[iy+6]*g0[iz+6]+ g1[ix+7]*g0[iy+7]*g0[iz+7];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3]+ g0[ix+4]*g1[iy+4]*g0[iz+4]+ g0[ix+5]*g1[iy+5]*g0[iz+5]+ g0[ix+6]*g1[iy+6]*g0[iz+6]+ g0[ix+7]*g1[iy+7]*g0[iz+7];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3]+ g0[ix+4]*g0[iy+4]*g1[iz+4]+ g0[ix+5]*g0[iy+5]*g1[iz+5]+ g0[ix+6]*g0[iy+6]*g1[iz+6]+ g0[ix+7]*g0[iy+7]*g1[iz+7];
break;
default:
CINTdset0(3, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];
} break;}
if (gout_empty) {
gout[0] = + (-1*c[1]*s[2]) + c[2]*s[1];
gout[1] = + (-1*c[2]*s[0]) + c[0]*s[2];
gout[2] = + (-1*c[0]*s[1]) + c[1]*s[0];
gout += 3;
} else {
gout[0] += + (-1*c[1]*s[2]) + c[2]*s[1];
gout[1] += + (-1*c[2]*s[0]) + c[0]*s[2];
gout[2] += + (-1*c[0]*s[1]) + c[1]*s[0];
gout += 3;
}}}
void cint2e_ig1_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ig1_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT k_sh = shls[2];
const FINT l_sh = shls[3];
if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (bas(ANG_OF,i_sh) * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (bas(ANG_OF,j_sh) * 2 + 1) * bas(NCTR_OF,j_sh);
FINT kp = (bas(ANG_OF,k_sh) * 2 + 1) * bas(NCTR_OF,k_sh);
FINT lp = (bas(ANG_OF,l_sh) * 2 + 1) * bas(NCTR_OF,l_sh);
CINTdset0(kp * ip * jp * lp * ng[TENSOR], opijkl);
return 0; }
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ig1_sph;
envs.common_factor *= 0.5;
return CINT2e_spheric_drv(opijkl, &envs, opt);
}
OPTIMIZER2F_(cint2e_ig1_sph_optimizer);
C2Fo_(cint2e_ig1_sph)
/* <G k G i|R12 |j l> : i,j \in electron 1; k,l \in electron 2
 * = (G i j|R12 |G k l) */
static void CINTgout2e_cint2e_ig1ig2_sph(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double s[9];
double rirj[3];
rirj[0] = ri[0] - rj[0];
rirj[1] = ri[1] - rj[1];
rirj[2] = ri[2] - rj[2];
double rkrl[3];
rkrl[0] = rk[0] - rl[0];
rkrl[1] = rk[1] - rl[1];
rkrl[2] = rk[2] - rl[2];
double c[9];
c[0] = 1 * rirj[0] * rkrl[0];
c[1] = 1 * rirj[0] * rkrl[1];
c[2] = 1 * rirj[0] * rkrl[2];
c[3] = 1 * rirj[1] * rkrl[0];
c[4] = 1 * rirj[1] * rkrl[1];
c[5] = 1 * rirj[1] * rkrl[2];
c[6] = 1 * rirj[2] * rkrl[0];
c[7] = 1 * rirj[2] * rkrl[1];
c[8] = 1 * rirj[2] * rkrl[2];
G2E_R0K(g1, g0, i_l+1, j_l+0, k_l+0, l_l);
G2E_R0I(g2, g0, i_l+0, j_l, k_l, l_l);
G2E_R0I(g3, g1, i_l+0, j_l, k_l, l_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(9, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[0] = + c[4]*s[8] + (-1*c[7]*s[5]) + (-1*c[5]*s[7]) + c[8]*s[4];
gout[1] = + c[5]*s[6] + (-1*c[8]*s[3]) + (-1*c[3]*s[8]) + c[6]*s[5];
gout[2] = + c[3]*s[7] + (-1*c[6]*s[4]) + (-1*c[4]*s[6]) + c[7]*s[3];
gout[3] = + c[7]*s[2] + (-1*c[1]*s[8]) + (-1*c[8]*s[1]) + c[2]*s[7];
gout[4] = + c[8]*s[0] + (-1*c[2]*s[6]) + (-1*c[6]*s[2]) + c[0]*s[8];
gout[5] = + c[6]*s[1] + (-1*c[0]*s[7]) + (-1*c[7]*s[0]) + c[1]*s[6];
gout[6] = + c[1]*s[5] + (-1*c[4]*s[2]) + (-1*c[2]*s[4]) + c[5]*s[1];
gout[7] = + c[2]*s[3] + (-1*c[5]*s[0]) + (-1*c[0]*s[5]) + c[3]*s[2];
gout[8] = + c[0]*s[4] + (-1*c[3]*s[1]) + (-1*c[1]*s[3]) + c[4]*s[0];
gout += 9;
} else {
gout[0] += + c[4]*s[8] + (-1*c[7]*s[5]) + (-1*c[5]*s[7]) + c[8]*s[4];
gout[1] += + c[5]*s[6] + (-1*c[8]*s[3]) + (-1*c[3]*s[8]) + c[6]*s[5];
gout[2] += + c[3]*s[7] + (-1*c[6]*s[4]) + (-1*c[4]*s[6]) + c[7]*s[3];
gout[3] += + c[7]*s[2] + (-1*c[1]*s[8]) + (-1*c[8]*s[1]) + c[2]*s[7];
gout[4] += + c[8]*s[0] + (-1*c[2]*s[6]) + (-1*c[6]*s[2]) + c[0]*s[8];
gout[5] += + c[6]*s[1] + (-1*c[0]*s[7]) + (-1*c[7]*s[0]) + c[1]*s[6];
gout[6] += + c[1]*s[5] + (-1*c[4]*s[2]) + (-1*c[2]*s[4]) + c[5]*s[1];
gout[7] += + c[2]*s[3] + (-1*c[5]*s[0]) + (-1*c[0]*s[5]) + c[3]*s[2];
gout[8] += + c[0]*s[4] + (-1*c[3]*s[1]) + (-1*c[1]*s[3]) + c[4]*s[0];
gout += 9;
}}}
void cint2e_ig1ig2_sph_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 1, 0, 2, 1, 1, 9};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ig1ig2_sph(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 0, 1, 0, 2, 1, 1, 9};
const FINT i_sh = shls[0];
const FINT j_sh = shls[1];
const FINT k_sh = shls[2];
const FINT l_sh = shls[3];
if (bas(ATOM_OF, i_sh) == bas(ATOM_OF, j_sh)) {
FINT ip = (bas(ANG_OF,i_sh) * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (bas(ANG_OF,j_sh) * 2 + 1) * bas(NCTR_OF,j_sh);
FINT kp = (bas(ANG_OF,k_sh) * 2 + 1) * bas(NCTR_OF,k_sh);
FINT lp = (bas(ANG_OF,l_sh) * 2 + 1) * bas(NCTR_OF,l_sh);
CINTdset0(kp * ip * jp * lp * ng[TENSOR], opijkl);
return 0; }
if (bas(ATOM_OF, k_sh) == bas(ATOM_OF, l_sh)) {
FINT ip = (bas(ANG_OF,i_sh) * 2 + 1) * bas(NCTR_OF,i_sh);
FINT jp = (bas(ANG_OF,j_sh) * 2 + 1) * bas(NCTR_OF,j_sh);
FINT kp = (bas(ANG_OF,k_sh) * 2 + 1) * bas(NCTR_OF,k_sh);
FINT lp = (bas(ANG_OF,l_sh) * 2 + 1) * bas(NCTR_OF,l_sh);
CINTdset0(kp * ip * jp * lp * ng[TENSOR], opijkl);
return 0; }
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ig1ig2_sph;
envs.common_factor *= -0.25;
return CINT2e_spheric_drv(opijkl, &envs, opt);
}
OPTIMIZER2F_(cint2e_ig1ig2_sph_optimizer);
C2Fo_(cint2e_ig1ig2_sph)
